{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


function tAnalyse.TTAbleitung(Funktion,Variable:PTermTyp):PTermTyp;
var ZwSp: PTermtyp;
begin
  If TTagleichb(Funktion,Variable) then
  begin
    new(RESULT);
    RESULT^.Opera:=001;
    RESULT^.ZahlGRaZ:=GRaZeins;
  end else
  begin
    CASE Funktion^.Opera OF
      001..002: begin
                  new(RESULT);
                  RESULT^.Opera:=001;
                  RESULT^.ZahlGRaZ:=GRaZnull;
                end; // 001..002
      004:      begin // (u+v)' = u'+v'
                  new(RESULT);
                  RESULT^.Opera:=004;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  RESULT^.Arg2:=TTAbleitung(Funktion^.Arg2,Variable);
                end; // 004
      005:      begin // (u*v)' = (u'*v)+(u*v')
                  new(RESULT);
                  RESULT^.Opera:=004;
                  new(RESULT^.Arg1);
                  new(RESULT^.Arg2);
                  RESULT^.Arg1^.Opera:=005;                                                                     // u'*v
                  RESULT^.Arg1^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  RESULT^.Arg1^.Arg2:=TTKopieVon(Funktion^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // u*v'
                  RESULT^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  RESULT^.Arg2^.Arg2:=TTAbleitung(Funktion^.Arg2,Variable);
                end; // 005
      006:      begin // (a^b)' = (_e^(b*ln(a)))' = (b*ln(a))' * _e^(b*ln(a));
                  new(ZwSp);                                                                                    // ZwSp := b*ln(a)
                  ZwSp^.Opera:=005;                                                                             // 005 = Multiplikation
                  ZwSp^.Arg1:=TTKopieVon(Funktion^.Arg2);
                  new(ZwSp^.Arg2);                                                                              // ln(b)
                  ZwSp^.Arg2^.Opera:=101;                                                                       // 101 = ln
                  ZwSp^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  ZwSp^.Arg2^.Arg2:=nil;
                  new(RESULT);                                                                                  // RESULT := (ZwSp)'*exp(ZwSp);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(ZwSp,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;                                                                     // 006=Potenz
                  new(RESULT^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Opera:=002;                                                               // 002=Variable oder Konstante
                  RESULT^.Arg2^.Arg1^.Konstante:=true;
                  RESULT^.Arg2^.Arg1^.Varname:='_e';
                  RESULT^.Arg2^.Arg2:=ZwSp;                                                                     // ZwSp muss also nicht freigegeben werden - es lebt in der Ableitung weiter.
                end; // 006
      101:      begin // (ln(x))' = (x)'*(x^(-1))
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);                                                                            // RESULT^.Arg2 := x^(-1)
                  RESULT^.Arg2^.Opera:=006;                                                                     // 006 = Potenz
                  RESULT^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;                                                               // 001=Zahl
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                        // (-1)
                end; // 101
      102:      begin // (exp(x))' = (x)'*exp(x)
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  RESULT^.Arg2:=TTKopieVon(Funktion);
                end; // 102
      103:      begin // (sin(x))' = (x)'*cos(x)
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  RESULT^.Arg2:=TTKopieVon(Funktion);                                                           // Zunächst wird sin(x) kopiert, dann dieser in ein cos(x) verwandelt:
                  RESULT^.Arg2^.Opera:=104;                                                                     // 104 = cos
                end; // 103
      104:      begin // (cos(x))' = (x)'*((-1)*sin(x))
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;
                  new(RESULT^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                        // (-1)
                  RESULT^.Arg2^.Arg2:=TTKopieVon(Funktion);                                                     // Zunächst wird cos(x) kopiert,
                  RESULT^.Arg2^.Arg2^.Opera:=103;                                                               // dann dieser in ein sin(x) verwandelt.
                end; // 104
      105:      begin // (tan(x))' = (x)'*(cos(x))^(-2);
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;
                  RESULT^.Arg2^.Arg1:=TTKopieVon(Funktion);                                                     // tan(x) wird kopiert...
                  RESULT^.Arg2^.Arg1.Opera:=104;                                                                // ... und in cos(x) umgewandelt.
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,true);                                        // (-2)
                end; // 105
      106:      begin // (cot(x))' = (-1)*((x')*((sin(x))^(-2)))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=006;                                                               // hoch (-2)
                  RESULT^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2^.Arg1^.Opera:=103;                                                         // 103 = sin; cot(x) --> sin(x)
                  new(RESULT^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,true);                                  // (-2)
                end; // 106
      107:      begin // (sec(x))' = (x)'*(sec(x)*tan(x))
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;
                  RESULT^.Arg2^.Arg1:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2^.Opera:=105                                                                // 105 = tan; sec(x) --> tan(x)
                end; // 107
      108:      begin // (csc(x))' = (-1)*((x')*(csc(x)*cot(x)))                         // <<-- KRITISCH: Ableitung von x wird nicht berücksichtigt!
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=005;                                                               // drittes *
                  RESULT^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2^.Arg2:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=106;                                                         // 106 = cot; csc(x) --> cot(x)
                end; // 108
      109:      begin // (abs(x))' = (x)'*sign(x)
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  RESULT^.Arg2:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Opera:=110;                                                                     // 110 = sign; abs(x) --> sign(x)
                end;
      110:      begin // (sign(x))' = 0
                  new(RESULT);
                  RESULT^.Opera:=001;
                  RESULT^.ZahlGRaZ:=GRaZnull;
                end; // 110
      111:      begin // (sinh(x))' = (x)'*cosh(x)
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  RESULT^.Arg2:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Opera:=112;                                                                      // 112 = cosh;; sinh(x) --> cosh(x)
                end; // 111
      112:      begin // (cosh(x))' = (x)'*sinh(x)
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  RESULT^.Arg2:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Opera:=111;                                                                      // 111 = sinh; cosh(x) --> sinh(x)
                end; // 112
      113:      begin // (tanh(x))' = (x)'*(sech(x))^2
                  new(RESULT);
                  RESULT^.Opera:=005;
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;
                  RESULT^.Arg2^.Arg1:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg1^.Opera:=115;                                                                // 115 = sech; tanh(x) --> sech(x)
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                                        // 2
                end; // 113
      114:      begin // (coth(x))' = (-1)*((x)'*((csch(x))^2))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                            // erstes *
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                               // (-1)
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                      // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=006;
                  RESULT^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2^.Arg1^.Opera:=116;                                                          // 116 = csch; coth(x) --> csch(x)
                  new(RESULT^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                                  // 2
                end; // 114
      115:      begin // (sech(x))' = (-1)*((x)'*(sech(x)*tanh(x)))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                              // (-1)
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=005;                                                               // drittes *
                  RESULT^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2^.Arg2:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=113;                                                         // 113 = tanh; sech(x) --> tanh(x)
                end; // 115
      116:      begin // (csch(x))' =  (-1)*((x)'*(csch(x)*coth(x)))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                              // (-1)
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=005;                                                               // drittes *
                  RESULT^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2^.Arg2:=TTKopieVon(Funktion);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=114;                                                         // 114 = coth; csch(x) --> coth(x)
                end; // 116
      117:      begin // (arcsin(x))'= (x)'*((1+((-1)*(x)^2))^(-1/2))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;                                                                     // äußeres ^
                  new(RESULT^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Opera:=004;                                                               // +
                  new(RESULT^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,false);                                 // 1
                  new(RESULT^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Opera:=005;                                                         // zweites *
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                            // (-1)
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=006;                                                   // inneres ^
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                     // 2
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,2,true);                                        // (-1/2)
                end; // 117
      118:      begin // (arccos(x))'= (-1)*((x)'*((1+((-1)*(x)^2))^(-1/2)))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                              // (-1)
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=006;                                                               // äußeres ^
                  new(RESULT^.Arg2^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Opera:=004;                                                         // +
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,false);                           // 1
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Opera:=005;                                                   // drittes *
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                      // (-1)
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=006;                                             // inneres ^
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);               // 2
                  new(RESULT^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,2,true);                                  // (-1/2)
                end; // 118
      119:      begin // (arctan(x))'= (x)'*((1+(x)^2)^(-1))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;                                                                     // äußeres ^
                  new(RESULT^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Opera:=004;                                                               // +
                  new(RESULT^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,false);                                 // 1
                  new(RESULT^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Opera:=006;                                                         // inneres ^
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                           // 2
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                        // (-1)
                end; // 119
      120:      begin // (arccot(x))'= (-1)*((x)'*((1+(x)^2)^(-1)))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                              // (-1)
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=006;                                                               // äußeres ^
                  new(RESULT^.Arg2^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Opera:=004;                                                         // +
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,false);                           // (1)
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Opera:=006;                                                   // inneres ^
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                     // 2
                  new(RESULT^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                  // (-1)
                end; // 120
      121:      begin // (arcsec(x))' = (x)'*((x^4+((-1)*x^2))^(-1/2))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;                                                                     // äußeres ^
                  new(RESULT^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Opera:=004;                                                               // +
                  new(RESULT^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg1^.Opera:=006;                                                          // 1. inneres ^
                  RESULT^.Arg2^.Arg1^.Arg1^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg1^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg1^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg1^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(4,1,false);                            // 4
                  new(RESULT^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Opera:=005;                                                         // zweites *
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                            // (-1)
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=006;                                                   // 2. inneres ^
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                     // 2
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,2,true);                                        // (-1/2)
                end; // 121
      122:      begin // (arccsc(x))'= (-1)*((x)'*((x^4+((-1)*x^2))^(-1/2)))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                              // (-1)
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=006;                                                               // äußeres ^
                  new(RESULT^.Arg2^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Opera:=004;                                                         // +
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1^.Opera:=006;                                                   // 1. inneres ^
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(4,1,false);                     // 4
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Opera:=005;                                                   // drittes *
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                      // (-1)
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=006;                                             // 2. inneres ^
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);               // 2
                  new(RESULT^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,2,true);                                  // (-1/2)
                end; // 122
      123:      begin // (arsinh(x))'= (x)'*((1+(x^2))^(-1/2))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;                                                                     // äußeres ^
                  new(RESULT^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Opera:=004;                                                               // +
                  new(RESULT^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,false);                                 // 1
                  new(RESULT^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Opera:=006;                                                         // inneres ^
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,2,true);                                        // (-1/2)
                end; // 123
      124:      begin // (arcosh(x))'= (x)'*(((-1)+(x^2))^(-1/2))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;                                                                     // äußeres ^
                  new(RESULT^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Opera:=004;                                                               // +
                  new(RESULT^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                  // (-1)
                  new(RESULT^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Opera:=006;                                                         // inneres ^
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                           // 2
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,2,true);                                        // (-1/2)
                end; // 124
      125:      begin // (artanh(x))'= (x)'*((1-x^2)^(-1))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;                                                                     // äußeres ^
                  new(RESULT^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Opera:=004;                                                               // +
                  new(RESULT^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,false);                                 // 1
                  new(RESULT^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Opera:=005;                                                         // zweites *
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                            // (-1)
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=006;                                                   // inneres ^
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                        // (-1)
                end;
      126:      begin // (arcoth(x))'= (x)'*((1-x^2)^(-1))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  RESULT^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=006;                                                                     // äußeres ^
                  new(RESULT^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Opera:=004;                                                               // +
                  new(RESULT^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,false);                                 // 1
                  new(RESULT^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Opera:=005;                                                         // zweites *
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                            // (-1)
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=006;                                                   // inneres ^
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                     // 2
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                        // (-1)
                end; // 126
      127:      begin // (arsech(x))'= (arccsc(x))'= (-1)*((x)'*((x^(-1))*((1+(-1)*x^2)^(-1/2)))))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                              // (-1)
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=005;                                                               // drittes *
                  new(RESULT^.Arg2^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Opera:=006;                                                         // 1. äußeres ^
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                            // (-1)
                  new(RESULT^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=006;                                                         // 2. äußeres ^
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Opera:=004;                                                   // +
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,false);                     // 1
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Opera:=005;                                             // viertes *
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                // (-1)
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=006;                                       // inneres ^
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);         // 2
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,2,true);                            // (-1/2)
                end; // 127
      128:      begin // (arcsch(x))'= (-1)*((x)'*((x^(-1))*((1+x^2)^(-1/2)))))
                  new(RESULT);
                  RESULT^.Opera:=005;                                                                           // erstes *
                  new(RESULT^.Arg1);
                  RESULT^.Arg1^.Opera:=001;
                  RESULT^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                              // (-1)
                  new(RESULT^.Arg2);
                  RESULT^.Arg2^.Opera:=005;                                                                     // zweites *
                  RESULT^.Arg2^.Arg1:=TTAbleitung(Funktion^.Arg1,Variable);
                  new(RESULT^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Opera:=005;                                                               // drittes *
                  new(RESULT^.Arg2^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg1^.Opera:=006;                                                         // 1. äußeres ^
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg1^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                            // (-1)
                  new(RESULT^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Opera:=006;                                                         // 2. äußeres ^
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Opera:=004;                                                   // +
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg1);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg1^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,false);                     // 1
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Opera:=006;                                             // inneres ^
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg1:=TTKopieVon(Funktion^.Arg1);
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);               // 2
                  new(RESULT^.Arg2^.Arg2^.Arg2^.Arg2);
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg2^.Opera:=001;
                  RESULT^.Arg2^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,2,true);                            // (-1/2)
                end; // 128
    END; // case
  end; // if TTagleichb(Funktion,Variable) else
end; // TTAbleitung


function tAnalyse.TTTaylorEntwicklung(Term, Variable, EntwPunkt:PTermTyp; Potenz:dword):PTermTyp;
var n: dword;
    ZwSpA, Ableitung, Laeufer: PTermTyp;
begin
  If Potenz=0 then RESULT:=UnbekannteErsetzen(Term, Variable, EntwPunkt) else if Potenz=1 then
  begin  // Taylor := f(a) + f'(a)*(x+(-1)*a); x=Variable, a=EntwPunkt, f(a)=TTUnbekannteErsetzen(Term,Variable,EntwPunkt)
    Ableitung:=TTAbleitung(Term,Variable);
    TTVereinfachung(Ableitung);
    new(RESULT);
    RESULT^.Opera := 004;
    RESULT^.Arg1 := UnbekannteErsetzen(Term, Variable, EntwPunkt);
    new(RESULT^.Arg2);
    RESULT^.Arg2^.Opera := 005;
    RESULT^.Arg2^.Arg1 := UnbekannteErsetzen(Ableitung, Variable, EntwPunkt);
    new(RESULT^.Arg2^.Arg2);
    RESULT^.Arg2^.Arg2^.Opera := 004;
    RESULT^.Arg2^.Arg2^.Arg1 := TTKopieVon(Variable);
    new(RESULT^.Arg2^.Arg2^.Arg2);
    RESULT^.Arg2^.Arg2^.Arg2^.Opera := 005;
    new(RESULT^.Arg2^.Arg2^.Arg2^.Arg1);
    RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.Opera := 001;
    RESULT^.Arg2^.Arg2^.Arg2^.Arg1^.ZahlGRaZ := WordToGRaZTyp(1,1,true);                                        // (-1)
    RESULT^.Arg2^.Arg2^.Arg2^.Arg2 := TTKopieVon(EntwPunkt);

    TTTermFreigabe(Ableitung);
  end else
  begin  // Taylor := f(a) + f'(a)*(x-a) + f''(a)/2!*(x-a)^2 + ... + f(n)(a)*(n!)^(-1)*(x-a)^n;
    new(RESULT);
    RESULT^.Opera:=004;
    RESULT^.Arg1:=UnbekannteErsetzen(Term,Variable,EntwPunkt);
    Laeufer:=RESULT;
    Ableitung:=TTAbleitung(Term,Variable);
    for n:=1 to Potenz do
    begin
      TTVereinfachung(Ableitung);
      new(Laeufer^.Arg2);
      Laeufer:=Laeufer^.Arg2;
      Laeufer^.Opera:=004;

      // ZwSpA:=(x+(-1)*a)^n
      new(ZwSpA);
      ZwSpA^.Opera:=006;
      new(ZwSpA^.Arg1);
      ZwSpA^.Arg1^.Opera:=004;
      ZwSpA^.Arg1^.Arg1:= TTKopieVon(Variable);
      new(ZwSpA^.Arg1^.Arg2);
      ZwSpA^.Arg1^.Arg2^.Opera:=005;
      new(ZwSpA^.Arg1^.Arg2^.Arg1);
      ZwSpA^.Arg1^.Arg2^.Arg1^.Opera:=001;
      ZwSpA^.Arg1^.Arg2^.Arg1^.ZahlGRaZ:= WordToGRaZTyp(1,1,true);                                              // (-1)
      ZwSpA^.Arg1^.Arg2^.Arg2:=TTKopieVon(EntwPunkt);
      new(ZwSpA^.Arg2);
      ZwSpA^.Arg2^.Opera:=001;
      ZwSpA^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(n,1,false);                                                          // ^n
      // Laeufer^.Arg1:= f(n)(a)*((1/n!)*ZwSpA)
      new(Laeufer^.Arg1);
      Laeufer^.Arg1^.Opera:=005;
      Laeufer^.Arg1^.Arg1:=UnbekannteErsetzen(Ableitung,Variable,EntwPunkt);
      new(Laeufer^.Arg1^.Arg2);
      Laeufer^.Arg1^.Arg2^.Opera:=005;
      new(Laeufer^.Arg1^.Arg2^.Arg1);
      Laeufer^.Arg1^.Arg2^.Arg1^.Opera:=001;                                                                    // 1/n!
      Laeufer^.Arg1^.Arg2^.Arg1^.ZahlGRaZ.Zaehler:=GNZeins;
      Laeufer^.Arg1^.Arg2^.Arg1^.ZahlGRaZ.Nenner :=GNZFakultaet(n);
      Laeufer^.Arg1^.Arg2^.Arg1^.ZahlGRaZ.Negativ:=false;
      Laeufer^.Arg1^.Arg2^.Arg2:=ZwSpA;

      ZwSpA:=Ableitung;
      Ableitung:=TTAbleitung(Ableitung,Variable);
      TTTermFreigabe(ZwSpA);
    end; // for
    ZwSpA:=Laeufer^.Arg1;                                                                                       // Bemerkung: Wenn Pointerfehler, dann muss letzter Summand gesondert abgehandelt werden.
    Laeufer^:=Laeufer^.Arg1^;
    Dispose(ZwSpA);
    TTTermFreigabe(Ableitung);
  end; // if Potenz=0 then else if Potenz=1 then else
end;  // TTTaylorEntwicklung
