{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


function TAnalyse.FunkWert_NM(Pointer:PTermTyp; XWert:double):double;
var Arg1,Arg2:double;  //Zwischenspeicher
begin
  Result:=1; //Initialisierung notwendig, da fuer err<>0 Result sonst mit einem <invalid float value> besetzt sein kann.
  CASE Pointer^.Opera OF
    001: Result:=Pointer^.GlKoZa;                                                             //001=Zahl  -  Agressiv programmiert. Bei Problemen muss ZahlGRaZ.Negativ beachtet werden.
    002: If not Pointer^.Konstante then Result:=XWert else                                    // Wenn es sich nicht um eine Konstante handelt, ersetzt er die Variable durch den Wert, der in die Funktion eingesetzt wird.
         begin
           If Pointer^.Varname = '_e' then Result:=2.7182818284590452353602874 else
            if Pointer^.Varname = '_pi' then Result:=pi;
         end; //002=Variable x und Konstanten
    004: begin                                                                                //004=Addition
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Arg2:=FunkWert_NM(Pointer^.Arg2,XWert);
           Result:=Arg1+Arg2;
         end;
    005: begin                                                                                //005=Multiplikation
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Arg2:=FunkWert_NM(Pointer^.Arg2,XWert);
           Result:=Arg1*Arg2;
         end;
    006: begin                                                                                //006=Potenz
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Arg2:=FunkWert_NM(Pointer^.Arg2,XWert);
           if (Arg2<0)and(Arg1=0) then Err:=1 else                                            //Division durch 0
           if (Arg2<>trunc(Arg2))and(Arg1<0) then Err:=13 else                                //Wurzel aus neg. Zahl
            Result:=power(Arg1,Arg2);
         end;
    101: begin                                                                                //101=ln
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If Arg1<=0 then Err:=2 else
            Result:=ln(Arg1);
         end;
//  102: Entfällt, da exp(x) durch _e^(x) ersetzt wurde
    103: begin                                                                                //103=sin
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=sin(Arg1);
         end;
    104: begin                                                                                //104=cos
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=cos(Arg1);
         end;
    105: begin                                                                                //105=tan
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=tan(Arg1);
         end;
    106: begin                                                                                //106=cot
           Arg1:=tan(FunkWert_NM(Pointer^.Arg1,XWert));
           If Arg1<>0 then Result:=1/Arg1 else Err:=2;
         end;
    107: begin                                                                                //107=sec
           Arg1:=cos(FunkWert_NM(Pointer^.Arg1,XWert));
           If Arg1<>0 then Result:=1/Arg1 else Err:=2;
         end;
    108: begin                                                                                //108=csc
           Arg1:=sin(FunkWert_NM(Pointer^.Arg1,XWert));
           If Arg1<>0 then Result:=1/Arg1 else Err:=2;
         end;
    109: begin                                                                                //109=abs
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=abs(Arg1);
         end;
    110: begin                                                                                //110=sign
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If Arg1>0 then Result:=1 else
            if Arg1<0 then Result:=-1 else Result:=0;
         end;
    111: begin                                                                                //111=sinh
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=sinh(Arg1);
         end;
    112: begin                                                                                //112=cosh
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=cosh(Arg1);
         end;
    113: begin                                                                                //113=tanh
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=tanh(Arg1);
         end;
    114: begin                                                                                //114=coth
           Arg1:=tanh(FunkWert_NM(Pointer^.Arg1,XWert));
           If Arg1<>0 then Result:=1/Arg1 else Err:=2;
         end;
    115: begin                                                                                //115=sech
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=1/cosh(Arg1);
         end;
    116: begin                                                                                //116=csch
           Arg1:=sinh(FunkWert_NM(Pointer^.Arg1,XWert));
           If Arg1<>0 then Result:=1/Arg1 else Err:=2;
         end;
    117: begin                                                                                //117=arcsin
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If (Arg1>=-1)and(Arg1<=1) then Result:=arcsin(Arg1) else Err:=2;
         end;
    118: begin                                                                                //118=arccos
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If (Arg1>=-1)and(Arg1<=1) then Result:=arccos(Arg1) else Err:=2;
         end;
    119: begin                                                                                //119=arctan
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=arctan(Arg1);
         end;
    120: begin                                                                                //120=arccot
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=pi/2 - arctan(Arg1);
         end;
    121: begin                                                                                //121=arcsec
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If (Arg1<=-1)or(Arg1>=1) then Result:=arccos(1/Arg1) else Err:=2;
         end;
    122: begin                                                                                //122=arccsc
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If (Arg1<=-1)or(Arg1>=1) then Result:=arcsin(1/Arg1) else Err:=2;
         end;
    123: begin                                                                                //123=arsinh
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           Result:=arcsinh(Arg1);
         end;
    124: begin                                                                                //124=arcosh
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If Arg1>=1 then Result:=arccosh(Arg1) else Err:=2;
         end;
    125: begin                                                                                //125=artanh
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If (Arg1>-1)and(Arg1<1) then Result:=arctanh(Arg1) else Err:=2;
         end;
    126: begin                                                                                //126=arcoth
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If (Arg1<-1)or(Arg1>1) then Result:=1/2*ln((Arg1+1)/(Arg1-1)) else Err:=2;
         end;
    127: begin                                                                                //127=arsech
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If (Arg1>0)and(Arg1<=1) then Result:=ln((1+sqrt(1-Arg1*Arg1))/Arg1) else Err:=2;
         end;
    128: begin                                                                                //128=arcsch
           Arg1:=FunkWert_NM(Pointer^.Arg1,XWert);
           If Arg1<>0 then Result:=ln(1/Arg1+sqrt(1+1/(Arg1*Arg1))) else Err:=2;
         end;

    else Result:=1;
  end; // CASE
end; //Funwert_NM
//0,01*(0,001*((1+x^2+x)^2+3+x^2+x*(x^3+1)-5*x^3-8*x)-x-1+0,001*((1+x^2+x)^2+3+x^2+x*(x^3+1)-5*x^3-8*x)-x-1)  Alt: 526 ms; Neu: 23 ms WOW!

function tAnalyse.UnbekannteErsetzen(Term, Unbekannte, Ersatz:PTermTyp):PTermTyp;
var ZwSp:PTermTyp;
begin
  If TTagleichb(Term, Unbekannte) then ZwSp:=TTKopieVon(Ersatz) else
  begin
    new(ZwSp);
    ZwSp^:=Term^;
    If (Term^.Opera>=4)and(Term^.Opera<=6) then
    begin
      ZwSp^.Arg1:=UnbekannteErsetzen(Term^.Arg1,Unbekannte,Ersatz);
      ZwSp^.Arg2:=UnbekannteErsetzen(Term^.Arg2,Unbekannte,Ersatz);
    end else if (Term^.Opera>=101)and(Term^.Opera<=128) then ZwSp^.Arg1:=UnbekannteErsetzen(Term^.Arg1,Unbekannte,Ersatz) else if Term^.Opera=001 then
    begin
      ZwSp^.ZahlGRaZ:=GRaZcopy(Term^.ZahlGRaZ);                                       // da sonst nur der Array-Pointer kopiert wird.
    end;
  end; // If Term=Unbekannte else
  RESULT:=ZwSp;
end; // TTUnbekannteErsetzen


procedure TAnalyse.Dezimalisierung(var Pointer:PTermTyp);
var ZwSp:double;
    Abbruch: boolean;                                                                         // Für Abbruch iterativer Schleifen.
begin
  // GGF muss Bereichsüberlauf noch geprüft werden.
  CASE Pointer^.Opera OF
    001: Pointer^.GlKoZa:=GRaZTypToDouble(Pointer^.ZahlGRaZ);                               //001=Zahl  -  Agressiv programmiert. Bei Problemen muss ZahlGRaZ.Negativ beachtet werden.
    002: If Pointer^.Konstante=true then                                                      //002=Variable/Konstante
         begin
           Pointer^.Opera:=001;
           Pointer^.ZahlGRaZ:=GRaZeins;
           if Pointer^.Varname='_pi' then Pointer^.GlKoZa:=Pi;
           if Pointer^.Varname='_e' then Pointer^.GlKoZa:=2.7182818284590452353;
         end; // 002
    004: begin                                                                                //004=Addition
           Dezimalisierung(Pointer^.Arg1);
           Dezimalisierung(Pointer^.Arg2);
           if (Pointer^.Arg1^.Opera=001) then
           begin
             Abbruch:=false;                                                                  //Folgender while-Absatz ist fürs Zusammenrechnen von 2+(3+(4+x)) --> 9+x notwendig.
             while (Pointer^.Arg2^.Opera=004)and(not Abbruch) do
             if Pointer^.Arg2^.Arg1^.Opera=001 then
             begin
               TTAssoz(Pointer,2);
               Pointer^.Arg1^.GlKoZa:=Pointer^.Arg1^.Arg1^.GlKoZa + Pointer^.Arg1^.Arg2^.GlKoZa;
               Pointer^.Arg1^.Opera:=001;
               Dispose(Pointer^.Arg1^.Arg1);
               Dispose(Pointer^.Arg1^.Arg2);
             end else Abbruch:=true; //while-if

             If (Pointer^.Arg2^.Opera=001) then
             begin
               Pointer^.ZahlGRaZ:=GRaZeins;                                                     // nur um Problemen vorzubeugen.
               Pointer^.GlKoZa:=Pointer^.Arg1^.GlKoZa + Pointer^.Arg2^.GlKoZa;
               Pointer^.Opera:=001;
               Dispose(Pointer^.Arg1);
               Dispose(Pointer^.Arg2);
             end;
           end;
         end; // 004
    005: begin                                                                                //005=Multiplikation
           Dezimalisierung(Pointer^.Arg1);
           Dezimalisierung(Pointer^.Arg2);
           if (Pointer^.Arg1^.Opera=001) then
           begin
             Abbruch:=false;                                                                  //Folgender while-Absatz ist fürs Zusammenrechnen von 2*(3*(4*x)) --> 24*x notwendig.
             while (Pointer^.Arg2^.Opera=005)and(not Abbruch) do
             if Pointer^.Arg2^.Arg1^.Opera=001 then
             begin
               TTAssoz(Pointer,2);
               Pointer^.Arg1^.GlKoZa:=Pointer^.Arg1^.Arg1^.GlKoZa * Pointer^.Arg1^.Arg2^.GlKoZa;
               Pointer^.Arg1^.Opera:=001;
               Dispose(Pointer^.Arg1^.Arg1);
               Dispose(Pointer^.Arg1^.Arg2);
             end else Abbruch:=true; //while-if

             If (Pointer^.Arg2^.Opera=001) then
             begin
               Pointer^.ZahlGRaZ:=GRaZeins;                                                     // nur um Problemen vorzubeugen.
               Pointer^.GlKoZa:=Pointer^.Arg1^.GlKoZa * Pointer^.Arg2^.GlKoZa;
               Pointer^.Opera:=001;
               Dispose(Pointer^.Arg1);
               Dispose(Pointer^.Arg2);
             end;
           end;
         end; // 005
    006: begin                                                                                //006=Potenz
           Dezimalisierung(Pointer^.Arg1);
           Dezimalisierung(Pointer^.Arg2);
           If (Pointer^.Arg1^.Opera=001)and(Pointer^.Arg2^.Opera=001) then
           begin
             if (Pointer^.Arg2^.GlKoZa<0)and(Pointer^.Arg1^.GlKoZa=0) then Err:=1 else        //Division durch 0
              if (Pointer^.Arg2^.GlKoZa<>trunc(Pointer^.Arg2^.GlKoZa))and(Pointer^.Arg1^.GlKoZa<0) then Err:=13 else   //Wurzel aus neg. Zahl
             begin
               Pointer^.ZahlGRaZ:=GRaZeins;
               Pointer^.GlKoZa:=power(Pointer^.Arg1^.GlKoZa, Pointer^.Arg2^.GlKoZa);
               Pointer^.Opera:=001;
               Dispose(Pointer^.Arg1);
               Dispose(Pointer^.Arg2);
             end;
           end;
         end; // 006
    101: begin                                                                                //101=ln
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if Pointer^.Arg1^.GlKoZa<=0 then Err:=2 else
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= ln(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 101
//  102: Entfällt, da exp(x) durch _e^x ersetzt wurde.
    103: begin                                                                                //103=sin
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= sin(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 103
    104: begin                                                                                //104=cos
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= cos(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 104
    105: begin                                                                                //105=tan
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= tan(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 105
    106: begin                                                                                //106=cot
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             ZwSp:= tan(Pointer^.Arg1^.GlKoZa);
             If ZwSp=0 then Err:=2 else
             begin
               Pointer^.ZahlGRaZ:=GRaZeins;
               Pointer^.GlKoZa:=1/ZwSp;
               Pointer^.Opera:=001;
               Dispose(Pointer^.Arg1);
             end;
           end;
         end; // 106
    107: begin                                                                                //107=sec
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             ZwSp:= cos(Pointer^.Arg1^.GlKoZa);
             If ZwSp=0 then Err:=2 else
             begin
               Pointer^.ZahlGRaZ:=GRaZeins;
               Pointer^.GlKoZa:=1/ZwSp;
               Pointer^.Opera:=001;
               Dispose(Pointer^.Arg1);
             end;
           end;
         end; // 107
    108: begin                                                                                //108=csc
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             ZwSp:= sin(Pointer^.Arg1^.GlKoZa);
             If ZwSp=0 then Err:=2 else
             begin
               Pointer^.ZahlGRaZ:=GRaZeins;
               Pointer^.GlKoZa:=1/ZwSp;
               Pointer^.Opera:=001;
               Dispose(Pointer^.Arg1);
             end;
           end;
         end; // 108
    109: begin                                                                                //109=abs
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= abs(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 109
    110: begin                                                                                //110=sign
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             If Pointer^.Arg1^.GlKoZa=0 then Pointer^.GlKoZa:=0
              else if Pointer^.Arg1^.GlKoZa>0 then Pointer^.GlKoZa:=1 else Pointer^.GlKoZa:=-1;
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 110
    111: begin                                                                                //111=sinh
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= sinh(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 111
    112: begin                                                                                //112=cosh
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= cosh(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 112
    113: begin                                                                                //113=tanh
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= tanh(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 113
    114: begin                                                                                //114=coth
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             ZwSp:= tanh(Pointer^.Arg1^.GlKoZa);
             If ZwSp=0 then Err:=2 else
             begin
               Pointer^.ZahlGRaZ:=GRaZeins;
               Pointer^.GlKoZa:=1/ZwSp;
               Pointer^.Opera:=001;
               Dispose(Pointer^.Arg1);
             end;
           end;
         end; // 114
    115: begin                                                                                //115=sech
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= 1/cosh(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 115
    116: begin                                                                                //116=csch
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             ZwSp:= sinh(Pointer^.Arg1^.GlKoZa);
             If ZwSp=0 then Err:=2 else
             begin
               Pointer^.ZahlGRaZ:=GRaZeins;
               Pointer^.GlKoZa:=1/ZwSp;
               Pointer^.Opera:=001;
               Dispose(Pointer^.Arg1);
             end;
           end;
         end; // 116
    117: begin                                                                                //117=arcsin
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if (Pointer^.Arg1^.GlKoZa>=-1)and(Pointer^.Arg1^.GlKoZa<=1) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:=arcsin(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end else Err:=2;
         end; // 117
    118: begin                                                                                //118=arccos
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if (Pointer^.Arg1^.GlKoZa>=-1)and(Pointer^.Arg1^.GlKoZa<=1) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:=arccos(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end else Err:=2;
         end; // 118
    119: begin                                                                                //119=arctan
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= arctan(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 119
    120: begin                                                                                //120=arccot
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= pi/2 - arctan(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; // 120
    121: begin                                                                                //121=arcsec
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if (Pointer^.Arg1^.GlKoZa<=-1)or(Pointer^.Arg1^.GlKoZa>=1) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:=arccos(1/Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end else Err:=2;
         end; // 121
    122: begin                                                                                //122=arccsc
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if (Pointer^.Arg1^.GlKoZa<=-1)or(Pointer^.Arg1^.GlKoZa>=1) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:=arcsin(1/Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end else Err:=2;
         end; // 122
    123: begin                                                                                //123=arsinh
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:= arcsinh(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end; //123
    124: begin                                                                                //124=arcosh
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if Pointer^.Arg1^.GlKoZa>=1 then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:=arccosh(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end else Err:=2;
         end; // 124
    125: begin                                                                                //125=artanh
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if (Pointer^.Arg1^.GlKoZa>-1)and(Pointer^.Arg1^.GlKoZa<1) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:=arctanh(Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end else Err:=2;
         end; // 125
    126: begin                                                                                //126=arcoth
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if (Pointer^.Arg1^.GlKoZa<-1)or(Pointer^.Arg1^.GlKoZa>1) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:=1/2*ln((Pointer^.Arg1^.GlKoZa+1)/(Pointer^.Arg1^.GlKoZa-1));
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end else Err:=2;
         end; // 126
    127: begin                                                                                //127=arsech
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if (Pointer^.Arg1^.GlKoZa>0)and(Pointer^.Arg1^.GlKoZa<=1) then
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:=ln((1+sqrt(1-Pointer^.Arg1^.GlKoZa*Pointer^.Arg1^.GlKoZa))/Pointer^.Arg1^.GlKoZa);
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end else Err:=2;
         end; // 127
    128: begin                                                                                //128=arcsch
           Dezimalisierung(Pointer^.Arg1);
           If (Pointer^.Arg1^.Opera=001) then if Pointer^.Arg1^.GlKoZa=0 then Err:=2 else
           begin
             Pointer^.ZahlGRaZ:=GRaZeins;
             Pointer^.GlKoZa:=ln(1/Pointer^.Arg1^.GlKoZa+sqrt(1+1/(Pointer^.Arg1^.GlKoZa*Pointer^.Arg1^.GlKoZa)));
             Pointer^.Opera:=001;
             Dispose(Pointer^.Arg1);
           end;
         end;
  end; // CASE
end; //Dezimalisierung
