{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


function tAnalyse.IstPrim(zahl:int64):boolean;
var n,wurzel:int64;
    Prim:boolean;
begin
  n:=1; wurzel:=trunc(sqrt(zahl));
  Prim:=true;
  If (zahl mod 2 = 0)or(zahl=1) then Prim:=false
  else
  repeat                        //klassischer Primzahltest
    inc(n,2);
    if zahl mod n = 0 then Prim:=false;
  until (n>=wurzel)or(Prim=false);
  If (zahl=2)or(zahl=3) then Prim:=true;
  IstPrim:=Prim;
end;

function tAnalyse.PrimDavor(zahl:int64):int64;
var n:int64;
begin
  If Zahl mod 2 = 0 then n:=Zahl+1 else n:=Zahl;
  repeat
    dec(n,2);
  until (IstPrim(n)=true)or(n<2);
  If n>=2 then PrimDavor:=n else Err:=12;
end;

function tAnalyse.PrimDanach(zahl:int64):int64;
var n:int64;
begin
  If Zahl mod 2 = 0 then n:=Zahl-1 else n:=Zahl;
  repeat
    inc(n,2);
  until (IstPrim(n)=true);
  PrimDanach:=n;
end;

function tAnalyse.ggt(a,b:int64):int64;   // Nach modernen Euklidischen Algorithmus
begin
  if b=0 then ggt:=a else ggt:=ggt(b, a mod b);
end;

function tAnalyse.kgv(a,b:int64):int64;   // über den ggT
begin
  kgv:=abs(a*b)div(ggt(a,b));
end;

// GNZ-Operationen (Rechnen mit Grosse Natuerlichen Zahlen)-------------------------------------------------------

function tAnalyse.GNZadd(a,b:GNZTyp):GNZTyp;
var ZwSp: dword;
    n,aAnz,bAnz: dword;
    Erg: GNZTyp;
begin
  aAnz:=length(a); bAnz:=length(b);
  ZwSp:=0;
  If aAnz<bAnz then
  begin
    setlength(Erg,bAnz);
    for n:=0 to aAnz-1 do
    begin
      ZwSp:= ZwSp + a[n] + b[n];
      If ZwSp>=GNZ_GlobZahlenbasis then
      begin
        Erg[n]:= ZwSp-GNZ_GlobZahlenbasis;
        ZwSp:=1;
      end else
      begin
        Erg[n]:=ZwSp;
        ZwSp:=0;
      end;
    end; //for n:=0 to aAnz-1;
    for n:=aAnz to bAnz-1 do
    begin
      ZwSp:= ZwSp + b[n];
      If ZwSp>=GNZ_GlobZahlenbasis then
      begin
        Erg[n]:= ZwSp-GNZ_GlobZahlenbasis;
        ZwSp:=1;
      end else
      begin
        Erg[n]:=ZwSp;
        ZwSp:=0;
      end;
    end; //for n:=aAnz to bAnz-1;
    If ZwSp<>0 then
    begin
      setlength(Erg,bAnz+1);
      Erg[bAnz]:=ZwSp;
    end;
  end else  //if aAnz<bAnz
  begin
    setlength(Erg,aAnz);
    for n:=0 to bAnz-1 do
    begin
      ZwSp:= ZwSp + a[n] + b[n];
      If ZwSp>=GNZ_GlobZahlenbasis then
      begin
        Erg[n]:= ZwSp-GNZ_GlobZahlenbasis;
        ZwSp:=1;
      end else
      begin
        Erg[n]:=ZwSp;
        ZwSp:=0;
      end;
    end; //for n:=0 to bAnz-1;
    for n:=bAnz to aAnz-1 do
    begin
      ZwSp:= ZwSp + a[n];
      If ZwSp>=GNZ_GlobZahlenbasis then
      begin
        Erg[n]:= ZwSp-GNZ_GlobZahlenbasis;
        ZwSp:=1;
      end else
      begin
        Erg[n]:=ZwSp;
        ZwSp:=0;
      end;
    end; //for n:=aAnz to bAnz-1;
    If ZwSp<>0 then
    begin
      setlength(Erg,aAnz+1);
      Erg[aAnz]:=ZwSp;
    end;
  end; //if aAnz<bAnz else
  Result:=Erg;
end; // GNZadd


function tAnalyse.GNZsub(Minuent,Subtrahend:GNZTyp):GNZTyp;
var ZwSp: dword;
    n,minn,maxn: dword;
    Erg,a,b: GNZTyp;
begin
  maxn:=length(Minuent); minn:=length(Subtrahend);
  If maxn<minn then
  begin
  end else a:=Minuent; b:=Subtrahend;            //hier ist kein copy() noetig, da a und b nicht veraendert werden.
  setlength(Erg,maxn);
  ZwSp:=0;

  for n:=0 to minn-1 do
  begin
    ZwSp:=ZwSp+b[n];
    If a[n]>=ZwSp then
    begin
      Erg[n]:=a[n] -ZwSp;
      ZwSp:=0;
    end else
    begin
      Erg[n]:=GNZ_GlobZahlenbasis - ZwSp + a[n];
      ZwSp:=1;
    end;
  end; //for n:=0 to minn-1;
  If maxn>minn then
  begin
    for n:=minn to maxn-1 do
    begin
      If a[n]>=ZwSp then
      begin
        Erg[n]:=a[n]-ZwSp;
        ZwSp:=0;
      end else
      begin
        Erg[n]:=GNZ_GlobZahlenbasis - ZwSp + a[n];
        ZwSp:=1;
      end;
    end; //for n:=minn-1 to maxn-1;
  end; // if maxn>minn
  n:=maxn-1;
  while (n>=1)and(Erg[n]=0) do
  begin
    dec(n);
  end; //while
  setlength(Erg,n+1);

  Result:=Erg;
end; //GNZsub


function tAnalyse.GNZmul(a,b:GNZTyp):GNZTyp;

    function GNZmul4Karazuba(a,b:GNZTyp;aAnz,bAnz:dword):GnzTyp;
    var n,na,nb,Ergmaxzeiger,Ueberschlag:dword;
        ZwSp:qword;
        Erg,ZwErg:GNZTyp;
    begin
      setlength(Erg,aAnz+bAnz);                                     //Erg wird auf maximale Ausgangslaenge gesetzt
      Erg[0]:=0;
      ErgMaxZeiger:=0;                                              //Zeigt auf hoechste Erg-Stelle
      ZwSp:=0;
      If NOT (((aAnz=1)and(a[0]=0))or((bAnz=1)and(b[0]=0))) then
      for na:=0 to aAnz-1 do
      begin
        setlength(ZwErg,na+bAnz+1);
        for nb:=0 to bAnz-1 do
        begin
          ZwSp:=qword(a[na])*b[nb] + ZwSp;
          If ZwSp<GNZ_GlobZahlenbasis then
          begin
            ZwErg[na+nb]:=ZwSp;
            ZwSp:=0;
          end else
          begin
            ZwErg[na+nb]:=ZwSp mod GNZ_GlobZahlenbasis;
            ZwSp:=ZwSp div GNZ_GlobZahlenbasis;
          end; //if zwsp<Zbasis
        end; //for bAnz
        If ZwSp<>0 then
        begin
          ZwErg[na+bAnz]:=ZwSp;
          ZwSp:=0;
          //BEGINN Optimierter Additionsalgorithmus:
          If na=0 then
          begin
            for n:=0 to bAnz do Erg[n]:=ZwErg[n];
            ErgMaxZeiger:=bAnz;
          end else
          begin
            Ueberschlag:=0;
            for n := na to ErgMaxZeiger do
            begin
              Ueberschlag := Ueberschlag + Erg[n] + ZwErg[n];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[n] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[n] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; //for n:=na to ErgMaxZeiger do
            if ErgMaxZeiger<>na+bAnz then
            begin
              inc(ErgMaxZeiger);
              Ueberschlag := Ueberschlag + ZwErg[ErgMaxZeiger];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[ErgMaxZeiger] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[ErgMaxZeiger] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; // if ErgMaxZeiger<>na+bAnz
            if ErgMaxZeiger<>na+bAnz then                                //koennte auch in einer while-Schleife
            begin                                                        //geloest werden, die sich dann max.
              inc(ErgMaxZeiger);                                         //2x aufruft-->Langsam
              Ueberschlag := Ueberschlag + ZwErg[ErgMaxZeiger];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[ErgMaxZeiger] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[ErgMaxZeiger] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; // if ErgMaxZeiger<>na+bAnz
            If Ueberschlag=1 then
            begin
              inc(ErgMaxZeiger);
              Erg[ErgMaxZeiger]:=1;
            end;
          end; //if na=0 else
          //ENDE Optimierter Additionsalgorithmus
        end else
        begin
          //setlength(ZwErg,na+bAnz);
          //BEGINN Optimierter Additionsalgorithmus:
          If na=0 then
          begin
            for n:=0 to bAnz-1 do Erg[n]:=ZwErg[n];
            ErgMaxZeiger:=bAnz-1;
          end else
          begin
            Ueberschlag:=0;
            If ErgMaxZeiger <> 0 then
            for n := na to ErgMaxZeiger do
            begin
              Ueberschlag := Ueberschlag + Erg[n] + ZwErg[n];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[n] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[n] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; //for n:=na to ErgMaxZeiger do
            if ErgMaxZeiger<>na+bAnz then
            begin
              inc(ErgMaxZeiger);
              Ueberschlag := Ueberschlag + ZwErg[ErgMaxZeiger];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[ErgMaxZeiger] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[ErgMaxZeiger] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; // if ErgMaxZeiger<>na+bAnz
            if ErgMaxZeiger<>na+bAnz then                                //koennte auch in einer while-Schleife
            begin                                                        //geloest werden, die sich dann max.
              inc(ErgMaxZeiger);                                         //2x aufruft-->Langsam
              Ueberschlag := Ueberschlag + ZwErg[ErgMaxZeiger];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[ErgMaxZeiger] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[ErgMaxZeiger] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; // if ErgMaxZeiger<>na+bAnz
            If Ueberschlag=1 then
            begin
              inc(ErgMaxZeiger);
              Erg[ErgMaxZeiger]:=1;
            end;
          end; //if na=0 else
          //ENDE Optimierter Additionsalgorithmus
        end;

        //ZwErg[na]:=0;
      end; //for aAnz
      If Erg[aAnz+bAnz-1]=0 then setlength(Erg,aAnz+bAnz-1);
      Result:=Erg;
    end; //function GNZmul4Karazuba

    function GNZKarazuba(a,b:GNZTyp;aAnz,bAnz,Laenge:dword):GNZTyp; //Implementierung des Karazuba-Algorithmus. Laenge=2^n
    var p,q,r,s,u,v,vFaktor1,vFaktor2,w,ZwSpGNZ,Erg :GNZTyp;
        n,n2,pAnz,qAnz,rAnz,sAnz,vFaktor1Anz,vFaktor2Anz,Laengediv2,uAnz,ZwSpAnz :dword;
        ZwSp :qword;
        vPositiv :boolean;
    begin
      If Laenge<>1 then
      begin
        Laengediv2:=Laenge div 2;
        //Geschwindigkeitsoptimiert: (dafuer Aufwendig in der Wartung und fehleranfaellig)
        If aAnz>Laengediv2 then
        begin
          //Erhalten von p,q:
          pAnz:=aAnz-Laengediv2;
          setlength(p,pAnz);
          n2:=Laengediv2-1;
          while (a[n2]=0)and(n2<>0) do dec(n2);
          qAnz:=n2+1;
          setlength(q,qAnz);
          for n:=0 to n2 do q[n]:=a[n];
          for n:=Laengediv2 to aAnz-1 do p[n-Laengediv2]:=a[n];
          If bAnz>Laengediv2 then
          begin
            //Erhalten von r,s:
            rAnz:=bAnz-Laengediv2;
            setlength(r,rAnz);
            n2:=Laengediv2-1;
            while (b[n2]=0)and(n2<>0) do dec(n2);
            sAnz:=n2+1;
            setlength(s,sAnz);
            for n:=0 to n2 do s[n]:=b[n];
            for n:=Laengediv2 to bAnz-1 do r[n-Laengediv2]:=b[n];
            //Karazuba:                                                         <-1
            If (pAnz<GNZ_Karazubagrenze)or(rAnz<GNZ_Karazubagrenze) then u:=GNZmul4Karazuba(p,r,pAnz,rAnz)
             else u:=GNZKarazuba(p,r,pAnz,rAnz,Laengediv2);
            if GNZakleinerb(q,p)=true then
            begin
              vPositiv:=false;
              vFaktor1:=GNZSub(p,q);
            end else
            begin
              vPositiv:=true;
              vFaktor1:=GNZSub(q,p);
            end;
            if GNZakleinerb(s,r) then
            begin
              vPositiv:= not vPositiv;
              vFaktor2:=GNZsub(r,s);
            end else vFaktor2:=GNZsub(s,r);
            vFaktor1Anz := length(vFaktor1);
            vFaktor2Anz := length(vFaktor2);
            If (vFaktor1Anz<GNZ_Karazubagrenze)or(vFaktor2Anz<GNZ_Karazubagrenze)
             then v := GNZmul4Karazuba(vFaktor1,vFaktor2,vFaktor1Anz,vFaktor2Anz)
             else v := GNZKarazuba(vFaktor1,vFaktor2,vFaktor1Anz,vFaktor2Anz,Laengediv2);
            If (qAnz<GNZ_Karazubagrenze)or(sAnz<GNZ_Karazubagrenze) then w := GNZmul4Karazuba(q,s,qAnz,sAnz)
             else w := GNZKarazuba(q,s,qAnz,sAnz,Laengediv2);
            If vPositiv=true then ZwSpGNZ:=GNZsub(GNZadd(u,w),v) else ZwSpGNZ:=GNZadd(GNZadd(u,w),v);
            //Nun wird u mit GlobZahlensystem^(2*Laengediv2), ZwSpGNZ mit GlobZahlensystem^Laengediv2 per Shift multipliziert;
            uAnz:=length(u);
            setlength(u,uAnz+Laenge);
            for n:=uAnz-1 downto 0 do u[n+Laenge]:=u[n];
            for n:=0 to Laenge-1 do u[n]:=0;
            ZwSpAnz:=length(ZwSpGNZ);
            setlength(ZwSpGNZ,ZwSpAnz+Laengediv2);
            for n:=ZwSpAnz-1 downto 0 do ZwSpGNZ[n+Laengediv2]:=ZwSpGNZ[n];
            for n:=0 to Laengediv2-1 do ZwSpGNZ[n]:=0;
            //Ergebnis der Multiplikation:
            Erg:=GNZadd(u,GNZadd(ZwSpGNZ,w));
          end else
          begin
            //r=0,s=b:                                                          <-2
            //Karazuba:
            if GNZakleinerb(q,p)=true then
            begin
              vPositiv:=false;
              vFaktor1:=GNZSub(p,q);
            end else
            begin
              vPositiv:=true;
              vFaktor1:=GNZSub(q,p);
            end;
            //vFaktor2:=b; (da s=b und r=0)
            vFaktor1Anz:=length(vFaktor1);
            If (vFaktor1Anz<GNZ_Karazubagrenze)or(bAnz<GNZ_Karazubagrenze)
             then v := GNZmul4Karazuba(vFaktor1,b,vFaktor1Anz,bAnz)
             else v := GNZKarazuba(vFaktor1,b,vFaktor1Anz,bAnz,Laengediv2);
            If (qAnz<GNZ_Karazubagrenze)or(bAnz<GNZ_Karazubagrenze) then w := GNZmul4Karazuba(q,b,qAnz,bAnz)
             else w := GNZKarazuba(q,b,qAnz,bAnz,Laengediv2);
            If vPositiv=true then ZwSpGNZ:=GNZsub(w,v) else ZwSpGNZ:=GNZadd(w,v);
            //Nun wird ZwSpGNZ mit GlobZahlensystem^Laengediv2 per Shift multipliziert;
            ZwSpAnz:=length(ZwSpGNZ);
            setlength(ZwSpGNZ,ZwSpAnz+Laengediv2);
            for n:=ZwSpAnz-1 downto 0 do ZwSpGNZ[n+Laengediv2]:=ZwSpGNZ[n];
            for n:=0 to Laengediv2-1 do ZwSpGNZ[n]:=0;
            //Ergebnis der Multiplikation:
            Erg:=GNZadd(ZwSpGNZ,w);
          end; //if-else bAnz>Laengediv2, im Fall von aAnz>Laengediv2
        end else
        begin
          //p=0,q=a:;
          If bAnz>Laengediv2 then
          begin
            //Erhalten von r,s:
            setlength(r,bAnz-Laengediv2);
            n2:=Laengediv2-1;
            while (b[n2]=0)and(n2<>0) do dec(n2);
            sAnz:=n2+1;
            setlength(s,sAnz);
            for n:=0 to n2 do s[n]:=b[n];
            //setlength(s,Laengediv2);
            //for n:=0 to Laengediv2-1 do s[n]:=b[n];
            for n:=Laengediv2 to bAnz-1 do r[n-Laengediv2]:=b[n];
            //Karazuba:                                                         <-3
            vPositiv:=true;
            if GNZakleinerb(s,r) then
            begin
              vPositiv:= not vPositiv;
              vFaktor2:=GNZsub(r,s);
            end else vFaktor2:=GNZsub(s,r);
            vFaktor2Anz:=length(vFaktor2);
            If (aAnz<GNZ_Karazubagrenze)or(vFaktor2Anz<GNZ_Karazubagrenze)
             then v := GNZmul4Karazuba(a,vFaktor2,aAnz,vFaktor2Anz)
             else v := GNZKarazuba(a,vFaktor2,aAnz,vFaktor2Anz,Laengediv2);
            If (aAnz<GNZ_Karazubagrenze)or(sAnz<GNZ_Karazubagrenze) then w := GNZmul4Karazuba(a,s,aAnz,sAnz)
             else w := GNZKarazuba(a,s,aAnz,sAnz,Laengediv2);
            If vPositiv=true then ZwSpGNZ:=GNZsub(w,v) else ZwSpGNZ:=GNZadd(w,v);
            //Nun wird ZwSpGNZ mit GlobZahlensystem^Laengediv2 per Shift multipliziert;
            ZwSpAnz:=length(ZwSpGNZ);
            setlength(ZwSpGNZ,ZwSpAnz+Laengediv2);
            for n:=ZwSpAnz-1 downto 0 do ZwSpGNZ[n+Laengediv2]:=ZwSpGNZ[n];
            for n:=0 to Laengediv2-1 do ZwSpGNZ[n]:=0;
            //Ergebnis der Multiplikation:
            Erg:=GNZadd(ZwSpGNZ,w);
          end else
          begin
            //r=0,s=b,p=0,q=a
            //Karazuba:                                                         <-4
            If (aAnz<GNZ_Karazubagrenze)or(bAnz<GNZ_Karazubagrenze) then Erg := GNZmul4Karazuba(a,b,aAnz,bAnz)
             else Erg := GNZKarazuba(a,b,aAnz,bAnz,Laengediv2);
          end; //if-else bAnz>Laengediv2, im Fall aAnz<=Laengediv2;
        end; //if-else aAnz>Laengediv2;
      end else
      begin
        //Schneller Algorithmus zur Multiplikation zweier einstelliger Zahlen:
        ZwSp:=a[0]*qword(b[0]);
        If ZwSp<GNZ_GlobZahlenbasis then
        begin
          setlength(Erg,1);
          Erg[0]:=ZwSp;
        end else
        begin
          setlength(Erg,2);
          Erg[1]:=ZwSp div GNZ_GlobZahlenbasis;
          Erg[0]:=ZwSp mod GNZ_GlobZahlenbasis;
        end; //If ZwSp<GNZ_GlobZahlenbasis
      end; //if Laenge<>1 else
      Result:=Erg;
    end; //GNZKarazuba

var n,na,nb,aAnz,bAnz,Ueberschlag,ErgMaxZeiger: dword;
    ZwSp:qword;
    Erg,ZwErg: GNZTyp;
begin
  aAnz:=length(a); bAnz:=length(b);
  If (aAnz<GNZ_Karazubagrenze)or(bAnz<GNZ_Karazubagrenze) then
  begin
    setlength(Erg,aAnz+bAnz);                                     //Erg wird auf maximale Ausgangslaenge gesetzt
    Erg[0]:=0;
    ErgMaxZeiger:=0;                                              //Zeigt auf hoechste Erg-Stelle
    ZwSp:=0;
    If NOT (((aAnz=1)and(a[0]=0))or((bAnz=1)and(b[0]=0))) then
    begin
      for na:=0 to aAnz-1 do
      begin
        setlength(ZwErg,na+bAnz+1);
        for nb:=0 to bAnz-1 do
        begin
          ZwSp:=qword(a[na])*b[nb] + ZwSp;
          If ZwSp<GNZ_GlobZahlenbasis then
          begin
            ZwErg[na+nb]:=ZwSp;
            ZwSp:=0;
          end else
          begin
            ZwErg[na+nb]:=ZwSp mod GNZ_GlobZahlenbasis;
            ZwSp:=ZwSp div GNZ_GlobZahlenbasis;
          end; //if zwsp<Zbasis
        end; //for bAnz
        If ZwSp<>0 then
        begin
          ZwErg[na+bAnz]:=ZwSp;
          ZwSp:=0;
          //BEGINN Optimierter Additionsalgorithmus:
          If na=0 then
          begin
            for n:=0 to bAnz do Erg[n]:=ZwErg[n];
            ErgMaxZeiger:=bAnz;
          end else
          begin
            Ueberschlag:=0;
            for n := na to ErgMaxZeiger do
            begin
              Ueberschlag := Ueberschlag + Erg[n] + ZwErg[n];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[n] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[n] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; //for n:=na to ErgMaxZeiger do
            if ErgMaxZeiger<>na+bAnz then
            begin
              inc(ErgMaxZeiger);
              Ueberschlag := Ueberschlag + ZwErg[ErgMaxZeiger];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[ErgMaxZeiger] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[ErgMaxZeiger] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; // if ErgMaxZeiger<>na+bAnz
            if ErgMaxZeiger<>na+bAnz then                                //koennte auch in einer while-Schleife
            begin                                                        //geloest werden, die sich dann max.
              inc(ErgMaxZeiger);                                         //2x aufruft-->Langsam
              Ueberschlag := Ueberschlag + ZwErg[ErgMaxZeiger];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[ErgMaxZeiger] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[ErgMaxZeiger] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; // if ErgMaxZeiger<>na+bAnz
            If Ueberschlag=1 then
            begin
              inc(ErgMaxZeiger);
              Erg[ErgMaxZeiger]:=1;
            end;
          end; //if na=0 else
          //ENDE Optimierter Additionsalgorithmus
        end else
        begin
          //setlength(ZwErg,na+bAnz);
          //BEGINN Optimierter Additionsalgorithmus:
          If na=0 then
          begin
            for n:=0 to bAnz-1 do Erg[n]:=ZwErg[n];
            ErgMaxZeiger:=bAnz-1;
          end else
          begin
            Ueberschlag:=0;
            If ErgMaxZeiger <> 0 then
            for n := na to ErgMaxZeiger do
            begin
              Ueberschlag := Ueberschlag + Erg[n] + ZwErg[n];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[n] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[n] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; //for n:=na to ErgMaxZeiger do
            if ErgMaxZeiger<>na+bAnz then
            begin
              inc(ErgMaxZeiger);
              Ueberschlag := Ueberschlag + ZwErg[ErgMaxZeiger];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[ErgMaxZeiger] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[ErgMaxZeiger] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; // if ErgMaxZeiger<>na+bAnz
            if ErgMaxZeiger<>na+bAnz then                                //koennte auch in einer while-Schleife
            begin                                                        //geloest werden, die sich dann max.
              inc(ErgMaxZeiger);                                         //2x aufruft-->Langsam
              Ueberschlag := Ueberschlag + ZwErg[ErgMaxZeiger];
              If Ueberschlag >= GNZ_GlobZahlenbasis then
              begin
                Erg[ErgMaxZeiger] := Ueberschlag - GNZ_GlobZahlenbasis;
                Ueberschlag := 1;
              end else
              begin
                Erg[ErgMaxZeiger] := Ueberschlag;
                Ueberschlag := 0;
              end;
            end; // if ErgMaxZeiger<>na+bAnz
            If Ueberschlag=1 then
            begin
              inc(ErgMaxZeiger);
              Erg[ErgMaxZeiger]:=1;
            end;
          end; //if na=0 else
          //ENDE Optimierter Additionsalgorithmus
        end;

        //ZwErg[na]:=0;
      end; //for aAnz
      If Erg[aAnz+bAnz-1]=0 then setlength(Erg,aAnz+bAnz-1);
    end else  // nun: wenn a=0 oder b=0:
    begin
      setlength(Erg,1);
      Erg[0]:=0;
    end;
  end else     //if Karazuba
  begin
    If aAnz<bAnz then na:=bAnz else na:=aAnz;        //In na steht die Stellenanz. des laengsten.
    n:=2;
    while n<na do n:=n*2;
    Erg:=GNZKarazuba(a,b,aAnz,bAnz,n);
  end;

  Result:=Erg;
end; //GNZmul


function tAnalyse.GNZmulword(a:dword;b:GNZtyp):GNZTyp;
var nb,bAnz: dword;
    ZwSp:qword;
    Erg: GNZTyp;
begin
  bAnz:=length(b);
  ZwSp:=0;
  setlength(Erg,bAnz+1);
  for nb:=0 to bAnz-1 do
  begin
    ZwSp:=qword(a)*b[nb] + ZwSp;
    If ZwSp<GNZ_GlobZahlenbasis then
    begin
      Erg[nb]:=ZwSp;
      ZwSp:=0;
    end else
    begin
      Erg[nb]:=ZwSp mod GNZ_GlobZahlenbasis;
      ZwSp:=ZwSp div GNZ_GlobZahlenbasis;                      //Ueberschlag
    end; //if zwsp<Zbasis
  end; //for bAnz
  If ZwSp<>0 then
  begin
    Erg[bAnz]:=ZwSp;
    ZwSp:=0;
  end else setlength(Erg,bAnz);
  Result:=Erg;
end; //GNZmulword


function tAnalyse.GNZakleinerb(a,b:GNZTyp):boolean;
var n:dword;
    Erg: boolean;
begin
  If length(a)<>length(b) then
  begin
    if length(a)<length(b) then Erg:=true else Erg:=false;
  end else
  begin
    n:=length(a);
    repeat
      dec(n);
    until (a[n]<>b[n])or(n=0);
    If a[n]<b[n] then Erg:=true else Erg:=false;
  end;
  Result:=Erg;
end;


function tAnalyse.GNZakleinerb(a:GNZTyp; b:dword):boolean;                             // b:dword;
begin
  If b>=GNZ_GlobZahlenbasis then Err:=12;                                              // Err=12: Ungültiger Zahlenbereich
  RESULT:= not (length(a)>1);
  If RESULT=true then RESULT:=a[0]<b;
end;


function tAnalyse.GNZakleinerb(a:dword; b:GNZTyp):boolean;
begin
  If a>=GNZ_GlobZahlenbasis then Err:=12;                                              // Err=12: Ungültiger Zahlenbereich
  RESULT:= length(b)>1;
  If RESULT=false then RESULT:=a<b[0];
end;


function tAnalyse.GNZagleichb(a,b:GNZTyp):boolean;
var n:dword;
    Erg: boolean;
begin
  If length(a)<>length(b) then Erg:=false else
  begin
    n:=length(a);
    repeat
      dec(n);
    until (a[n]<>b[n])or(n=0);
    If a[n]=b[n] then Erg:=true else Erg:=false;
  end;
  Result:=Erg;
end;


function tAnalyse.GNZagleichb(a:GNZTyp; b:dword):boolean;
begin
  If b>=GNZ_GlobZahlenbasis then Err:=12;                                              // Err=12: Ungültiger Zahlenbereich
  RESULT:= length(a)=1;
  If RESULT=true then RESULT:= a[0]=b;
end;


function tAnalyse.GNZeins:GNZTyp;
var ZwSp:GNZTyp;
begin
  setlength(ZwSp,1);
  ZwSp[0]:=1;
  Result:=ZwSp;
end;

function tAnalyse.GNZnull:GNZTyp;
var ZwSp:GNZTyp;
begin
  setlength(ZwSp,1);
  ZwSp[0]:=0;
  Result:=ZwSp;
end;


function tAnalyse.GNZdiv(Divident,Divisor:GNZTyp):GNZTyp;
var ZwSp:qword;
    LaengeDivident, LaengeDivisor, LaengeErg, n:dword;
    Faktor,uGrenze:dword;
    n_dent, n_sor, n_erg:longint;
    Erg, ZwSpGNZ, ZwErgGNZ, Produkt: GNZTyp;
begin
  //testt2:=0;
  If GNZakleinerb(Divisor,Divident) then
  begin
    LaengeDivident:=length(Divident); LaengeDivisor:=length(Divisor);
    If LaengeDivisor=1 then
    begin
      If Divisor[0]=0 then
      begin
        Err:=1;
        setlength(Erg,1);                                                   // Um Speicherzugriffsverletzungen zu vermeiden, wird Erg trotzdem erzeugt.
        Erg[0]:=1;
      end else
      If LaengeDivident=1 then
      begin
        SetLength(Erg,1);
        Erg[0]:=Divident[0] div Divisor[0];
      end else  // LaengeDivident=1
      begin
        //Schulmethode: Schriftliche Division mit einziffrigem Divisor, geschwindigkeitsoptimiert.
        ZwSp:=0;
        n_dent:=LaengeDivident-1;                                 //zeigt auf hoechste Ziffer

        If Divident[n_dent]<Divisor[0] then
        begin
          setlength(Erg,n_dent);                                  //da n_dent=LaengeDivident-1
          ZwSp:=Divident[n_dent]*qword(GNZ_GlobZahlenbasis);
          dec(n_dent);                                            //im Folgenden wurde n_erg durch n_dent ersetzt, da ab hier beide gleiche Werte beinhalten
        end else setlength(Erg,LaengeDivident); //if Divident[n_dent]<Divisor[0] else

        while n_dent<>0 do
        begin
          ZwSp:=ZwSp + Divident[n_dent];
          Erg[n_dent]:=ZwSp div Divisor[0];
          ZwSp := (ZwSp mod Divisor[0])*qword(GNZ_GlobZahlenbasis);
          dec(n_dent);
        end;//while
        ZwSp:=ZwSp + Divident[0];
        Erg[0]:=ZwSp div Divisor[0];
        //ZwSp:=ZwSp mod Divisor[0]; <--- modulo
      end; //if LaengeDivident=1 else
    end else  //LaengeDivisor=1
    begin
      //Schulmethode: Schriftliche Division mit mehrziffrigem Divisor, geschwindigkeitsoptimiert.
      n:=0;
      repeat
        inc(n);
      until (Divident[LaengeDivident-n]<>Divisor[LaengeDivisor-n])or(n=LaengeDivisor);
      If Divident[LaengeDivident-n]<Divisor[LaengeDivisor-n] then
      begin
        LaengeErg:=LaengeDivident-LaengeDivisor;
        setlength(Erg,LaengeErg);
        setlength(ZwSpGNZ,LaengeDivisor+1);
        for n:=0 to LaengeDivisor do ZwSpGNZ[n]:=Divident[LaengeErg-1+n]; //da LaengeErg=LaengeDivident-LaengeDivisor (!)
      end else
      begin
        LaengeErg:=LaengeDivident-LaengeDivisor+1;
        setlength(Erg,LaengeErg);
        setlength(ZwSpGNZ,LaengeDivisor);
        for n:=0 to LaengeDivisor-1 do ZwSpGNZ[n]:=Divident[LaengeDivident-LaengeDivisor+n];
      end; //If Divident[LaengeDivident-n]<Divisor[LaengeDivisor-n] else
      n_erg:=LaengeErg-1; n_dent:=LaengeErg-2;  //Zeigen auf vorderste noch nicht verarbeitete Ziffer
      n_sor:=LaengeDivisor-1;                   //Zeigt auf 1. Ziffer des Divisors

      while n_dent<>-1 do
      begin
        If length(ZwSpGNZ)=LaengeDivisor then ZwSp:=ZwSpGNZ[n_sor]
         else ZwSp:=ZwSpGNZ[LaengeDivisor]*qword(GNZ_GlobZahlenbasis) + ZwSpGNZ[n_sor];
        //ANFANG Division des Zwischenergebnisses ZwSpGNZ
        uGrenze:= ZwSp div (Divisor[n_sor]+1);
        Faktor := 0;
        ZwErgGNZ:=copy(ZwSpGNZ);
        while uGrenze<>0 do
        begin
          Faktor:=Faktor+uGrenze;
          Produkt:=GNZmulword(uGrenze,Divisor);
          ZwErgGNZ:=GNZsub(ZwErgGNZ,Produkt);
          If length(ZwErgGNZ)>LaengeDivisor then ZwSp:=ZwErgGNZ[LaengeDivisor]*qword(GNZ_GlobZahlenbasis) + ZwErgGNZ[n_sor]
           else if length(ZwErgGNZ)<LaengeDivisor then ZwSp:=0
           else ZwSp:=ZwErgGNZ[n_sor];
          uGrenze:= ZwSp div (Divisor[n_sor]+1);
        end;
        If GNZakleinerb(ZwErgGNZ,Divisor)=false then Faktor:=Faktor+1;

        Produkt:=GNZmulword(Faktor,Divisor);
        Erg[n_erg]:=Faktor;
        dec(n_erg);
        //ENDE Division des Zwischenergebnisses ZwSpGNZ
        ZwSpGNZ:= GNZsub(ZwSpGNZ,Produkt);
        If (length(ZwSpGNZ)=1)and(ZwSpGNZ[0]=0) then                        //D.h. ZwSpGNZ=GNZnull
        begin
          while (n_dent<>-1)and(Divident[n_dent]=0) do
          begin
            Erg[n_erg]:=0;
            dec(n_erg);
            dec(n_dent);
          end;
          If n_dent<>-1 then
          begin
            Erg[n_erg]:=0;
            dec(n_erg);
            ZwSpGNZ[0]:=Divident[n_dent];
            dec(n_dent);
          end;
        end; // If ZwSpGNZ=GNZnull
        If n_dent <> -1 then
        begin
          setlength(ZwSpGNZ,length(ZwSpGNZ)+1);
          for n:=length(ZwSpGNZ)-2 downto 0 do ZwSpGNZ[n+1]:=ZwSpGNZ[n];     //Um 1 Stelle nach links verschieben
          ZwSpGNZ[0]:=Divident[n_dent];
          dec(n_dent);
        end; // if n_dent <> -1
        while (n_dent<>-1)and(GNZakleinerb(ZwSpGNZ,Divisor)=true) do
        begin
          Erg[n_erg]:=0;
          dec(n_erg);
          setlength(ZwSpGNZ,length(ZwSpGNZ)+1);
          for n:=length(ZwSpGNZ)-2 downto 0 do ZwSpGNZ[n+1]:=ZwSpGNZ[n];     //Um 1 Stelle nach links verschieben
          ZwSpGNZ[0]:=Divident[n_dent];
          dec(n_dent);
        end; //while (n_dent<>-1)and(GNZakleinerb(ZwSpGNZ,Divisor)=true)
      end; //while n_dent<>-1
      If GNZakleinerb(ZwSpGNZ,Divisor)=true then
      begin
        If n_erg<>-1 then Erg[n_erg]:=0
      end else
      begin
        If length(ZwSpGNZ)=LaengeDivisor then ZwSp:=ZwSpGNZ[n_sor]
         else ZwSp:=ZwSpGNZ[LaengeDivisor]*qword(GNZ_GlobZahlenbasis) + ZwSpGNZ[n_sor];
        //ANFANG Division des Zwischenergebnisses ZwSpGNZ
        uGrenze:= ZwSp div (Divisor[n_sor]+1);
        Faktor := 0;
        ZwErgGNZ:=copy(ZwSpGNZ);
        while uGrenze<>0 do
        begin
          Faktor:=Faktor+uGrenze;
          Produkt:=GNZmulword(uGrenze,Divisor);
          ZwErgGNZ:=GNZsub(ZwErgGNZ,Produkt);
          If length(ZwErgGNZ)>LaengeDivisor then ZwSp:=ZwErgGNZ[LaengeDivisor]*qword(GNZ_GlobZahlenbasis) + ZwErgGNZ[n_sor]
           else if length(ZwErgGNZ)<LaengeDivisor then ZwSp:=0
           else ZwSp:=ZwErgGNZ[n_sor];
          uGrenze:= ZwSp div (Divisor[n_sor]+1);
        end;
        If GNZakleinerb(ZwErgGNZ,Divisor)=false then Faktor:=Faktor+1;

        Produkt:=GNZmulword(Faktor,Divisor);
        Erg[n_erg]:=Faktor;
        dec(n_erg);
        //ENDE Division des Zwischenergebnisses ZwSpGNZ
      end; //If GNZakleinerb(ZwSpGNZ,Divisor) else
      //ZwSpGNZ:= GNZsub(ZwSpGNZ,Produkt); <--- modulo
    end; //if LaengeDivisor=1 else

  end else if GNZagleichb(Divisor,Divident) then
  begin
    if (length(Divisor)=1)and(Divisor[0]=0) then Err:=1;
    setlength(Erg,1);
    Erg[0]:=1;
  end else
  begin
    setlength(Erg,1);
    Erg[0]:=0;
  end;
  Result:=Erg;
end; // GNZDiv


function tAnalyse.GNZmod(Divident, Divisor:GNZTyp):GNZTyp;
var ZwSp:qword;
    LaengeDivident, LaengeDivisor, n:dword;
    Faktor,uGrenze:dword;
    n_dent, n_sor:longint;
    ZwSpGNZ, ZwErgGNZ, Produkt: GNZTyp;
begin
  If GNZakleinerb(Divisor,Divident) then
  begin
    LaengeDivident:=length(Divident); LaengeDivisor:=length(Divisor);
    If LaengeDivisor=1 then
    begin
      If Divisor[0]=0 then
      begin
        Err:=1;
        setlength(RESULT,1);                                                   // Um Speicherzugriffsverletzungen zu vermeiden, wird RESULT trotzdem erzeugt.
        RESULT[0]:=1;
      end else
      If LaengeDivident=1 then
      begin
        SetLength(Result,1);
        Result[0]:=Divident[0] mod Divisor[0];
      end else  // LaengeDivident=1
      begin
        //Schulmethode: Schriftliche Division mit einziffrigem Divisor, geschwindigkeitsoptimiert.
        ZwSp:=0;
        n_dent:=LaengeDivident-1;                                 //zeigt auf hoechste Ziffer

        If Divident[n_dent]<Divisor[0] then
        begin;                                  //da n_dent=LaengeDivident-1
          ZwSp:=Divident[n_dent]*qword(GNZ_GlobZahlenbasis);
          dec(n_dent);
        end; //if Divident[n_dent]<Divisor[0] else

        while n_dent<>0 do
        begin
          ZwSp:=ZwSp + Divident[n_dent];
          ZwSp := (ZwSp mod Divisor[0])*qword(GNZ_GlobZahlenbasis);
          dec(n_dent);
        end;//while
        ZwSp:=ZwSp + Divident[0];
        setlength(Result,1);
        Result[0]:=ZwSp mod Divisor[0]; //<--- modulo
      end; //if LaengeDivident=1 else
    end else  //LaengeDivisor=1
    begin
      //Schulmethode: Schriftliche Division mit mehrziffrigem Divisor, geschwindigkeitsoptimiert.
      n:=0;
      repeat
        inc(n);
      until (Divident[LaengeDivident-n]<>Divisor[LaengeDivisor-n])or(n=LaengeDivisor);
      If Divident[LaengeDivident-n]<Divisor[LaengeDivisor-n] then
      begin
        n_dent:=LaengeDivident-LaengeDivisor-2;
        setlength(ZwSpGNZ,LaengeDivisor+1);
        for n:=0 to LaengeDivisor do ZwSpGNZ[n]:=Divident[n_dent+1+n]; //da LaengeErg=LaengeDivident-LaengeDivisor (!)
      end else
      begin
        n_dent:=LaengeDivident-LaengeDivisor-1;
        setlength(ZwSpGNZ,LaengeDivisor);
        for n:=0 to LaengeDivisor-1 do ZwSpGNZ[n]:=Divident[LaengeDivident-LaengeDivisor+n];
      end; //If Divident[LaengeDivident-n]<Divisor[LaengeDivisor-n] else
      n_sor:=LaengeDivisor-1;                   //Zeigt auf 1. Ziffer des Divisors

      while n_dent<>-1 do
      begin
        If length(ZwSpGNZ)=LaengeDivisor then ZwSp:=ZwSpGNZ[n_sor]
         else ZwSp:=ZwSpGNZ[LaengeDivisor]*qword(GNZ_GlobZahlenbasis) + ZwSpGNZ[n_sor];
        //ANFANG Division des Zwischenergebnisses ZwSpGNZ
        uGrenze:= ZwSp div (Divisor[n_sor]+1);
        Faktor := 0;
        ZwErgGNZ:=copy(ZwSpGNZ);
        while uGrenze<>0 do
        begin
          Faktor:=Faktor+uGrenze;
          Produkt:=GNZmulword(uGrenze,Divisor);
          ZwErgGNZ:=GNZsub(ZwErgGNZ,Produkt);
          If length(ZwErgGNZ)>LaengeDivisor then ZwSp:=ZwErgGNZ[LaengeDivisor]*qword(GNZ_GlobZahlenbasis) + ZwErgGNZ[n_sor]
           else if length(ZwErgGNZ)<LaengeDivisor then ZwSp:=0
           else ZwSp:=ZwErgGNZ[n_sor];
          uGrenze:= ZwSp div (Divisor[n_sor]+1);
        end;
        If GNZakleinerb(ZwErgGNZ,Divisor)=false then Faktor:=Faktor+1;

        Produkt:=GNZmulword(Faktor,Divisor);
        //ENDE Division des Zwischenergebnisses ZwSpGNZ
        ZwSpGNZ:= GNZsub(ZwSpGNZ,Produkt);
        If (length(ZwSpGNZ)=1)and(ZwSpGNZ[0]=0) then                        //D.h. ZwSpGNZ=GNZnull
        begin
          while (n_dent<>-1)and(Divident[n_dent]=0) do
          begin
            dec(n_dent);
          end;
          If n_dent<>-1 then
          begin
            ZwSpGNZ[0]:=Divident[n_dent];
            dec(n_dent);
          end;
        end; // If ZwSpGNZ=GNZnull
        If n_dent <> -1 then
        begin
          setlength(ZwSpGNZ,length(ZwSpGNZ)+1);
          for n:=length(ZwSpGNZ)-2 downto 0 do ZwSpGNZ[n+1]:=ZwSpGNZ[n];     //Um 1 Stelle nach links verschieben
          ZwSpGNZ[0]:=Divident[n_dent];
          dec(n_dent);
        end; // if n_dent <> -1
        while (n_dent<>-1)and(GNZakleinerb(ZwSpGNZ,Divisor)=true) do
        begin
          setlength(ZwSpGNZ,length(ZwSpGNZ)+1);
          for n:=length(ZwSpGNZ)-2 downto 0 do ZwSpGNZ[n+1]:=ZwSpGNZ[n];     //Um 1 Stelle nach links verschieben
          ZwSpGNZ[0]:=Divident[n_dent];
          dec(n_dent);
        end; //while (n_dent<>-1)and(GNZakleinerb(ZwSpGNZ,Divisor)=true)
      end; //while n_dent<>-1
      If GNZakleinerb(ZwSpGNZ,Divisor)=true then
      begin
        //If n_erg<>-1 then Erg[n_erg]:=0
        Result:=ZwSpGNZ;
      end else
      begin
        If length(ZwSpGNZ)=LaengeDivisor then ZwSp:=ZwSpGNZ[n_sor]
         else ZwSp:=ZwSpGNZ[LaengeDivisor]*qword(GNZ_GlobZahlenbasis) + ZwSpGNZ[n_sor];
        //ANFANG Division des Zwischenergebnisses ZwSpGNZ
        uGrenze:= ZwSp div (Divisor[n_sor]+1);
        Faktor := 0;
        ZwErgGNZ:=copy(ZwSpGNZ);
        while uGrenze<>0 do
        begin
          Faktor:=Faktor+uGrenze;
          Produkt:=GNZmulword(uGrenze,Divisor);
          ZwErgGNZ:=GNZsub(ZwErgGNZ,Produkt);
          If length(ZwErgGNZ)>LaengeDivisor then ZwSp:=ZwErgGNZ[LaengeDivisor]*qword(GNZ_GlobZahlenbasis) + ZwErgGNZ[n_sor]
           else if length(ZwErgGNZ)<LaengeDivisor then ZwSp:=0
           else ZwSp:=ZwErgGNZ[n_sor];
          uGrenze:= ZwSp div (Divisor[n_sor]+1);
        end;
        If GNZakleinerb(ZwErgGNZ,Divisor)=false then Faktor:=Faktor+1;

        Produkt:=GNZmulword(Faktor,Divisor);
        //ENDE Division des Zwischenergebnisses ZwSpGNZ
        Result:= GNZsub(ZwSpGNZ,Produkt);
      end; //If GNZakleinerb(ZwSpGNZ,Divisor) else
    end; //if LaengeDivisor=1 else

  end else if GNZagleichb(Divisor,Divident) then
  begin
    if (length(Divisor)=1)and(Divisor[0]=0) then Err:=1;
    setlength(Result,1);
    Result[0]:=0;
  end else
  begin
    Result:=copy(Divident);
  end;
end; //GNZmod


function tAnalyse.GNZggt(a,b:GNZTyp):GNZTyp;   // Nach modernen Euklidischen Algorithmus
begin
  if (length(b)=1)and(b[0]=0) then Result:=a else Result:=GNZggt(b, GNZmod(a,b));
end;


function tAnalyse.GNZkgv(a,b:GNZTyp):GNZTyp;   // über den ggT
begin
  GNZkgv:=GNZdiv(GNZmul(a,b),GNZggt(a,b));
end;


function tAnalyse.GNZIstGerade(zahl:GNZTyp):boolean;
var n, ugz:integer;
begin
  If GNZ_GlobZahlenbasis mod 2 = 0 then
  begin
    if zahl[0] mod 2 = 0 then Result:=true else Result:=false;
  end else
  begin
    ugz:=0;
    for n:=0 to length(zahl)-1 do
    begin
      if zahl[n] mod 2 <>0 then inc(ugz);
    end;
    if ugz mod 2 = 0 then Result:=true else Result:=false;
  end;
end; //GNZistgerade


function tAnalyse.GNZPotenz(Basis,Exponent:GNZTyp):GNZTyp; //Algorithmus im Internet gefunden. Dieser ist aber auch logisch.
var z,e,Erg,eins,zwei:GNZTyp;
begin
  z:=copy(Basis);
  e:=copy(Exponent);
  setlength(eins,1);
  eins[0]:=1;
  setlength(Erg,1);
  Erg[0]:=1;
  zwei:=GNZadd(eins,eins);

  while not ((length(e)=1)and(e[0]=0)) do
  begin
    If GNZistgerade(e) then
    begin
      e:=GNZdiv(e,zwei);
      z:=GNZmul(z,z);
    end else
    begin
      e:=GNZsub(e,eins);
      Erg:=GNZmul(Erg,z);
    end;
  end; //while
  Result:=Erg;
end; //GNZPotenz


function tAnalyse.GNZPotenzModulo(Basis,Exponent,Modulo:GNZTyp):GNZTyp; //Basiert auf Satz [a*b] mod n = [(a mod n)*(b mod n)] mod n, sowie (a^e mod n)^d mod n = a^(e*d) mod n
var z,e,Erg,eins,zwei:GNZTyp;
begin
  z:=GNZmod(Basis,Modulo);
  e:=copy(Exponent);
  setlength(eins,1);
  eins[0]:=1;
  setlength(Erg,1);
  Erg[0]:=1;
  zwei:=GNZadd(eins,eins);

  while not ((length(e)=1)and(e[0]=0)) do
  begin
    If GNZistgerade(e) then
    begin
      e:=GNZdiv(e,zwei);
      z:=GNZmod(GNZmul(z,z),Modulo);
    end else
    begin
      e:=GNZsub(e,eins);
      Erg:=GNZmod(GNZmul(Erg,z),Modulo);
    end;
  end; //while
  Result:=Erg;
end; //GNZPotenzModulo


function tAnalyse.GNZFakultaet(nFak:dword):GNZTyp;
var n:dword;
    Erg,ZwSpGNZ:GNZTyp;
begin
  setlength(Erg,1); Erg[0]:=1;
  setlength(ZwSpGNZ,1);
  for n:=2 to nFak do
  begin
    ZwSpGNZ[0]:=n;
    Erg:=GNZmul(ZwSpGNZ,Erg);
  end;
  Result:=Erg;
end; //GNZFakultaet


function tAnalyse.GNZNueberK(N,K:dword):GNZTyp;
var i, Grenze: dword;
    ZaehlerGNZ, NennerGNZ, ZwSpGNZ: GNZTyp;
begin // Stark optimierte Methode zum Berechnen von N über K
  If K<=N then
  begin
    // Zaehler berechnen
    Grenze:=K+1;                                                                  // Optimierung, damit keine unnötigen Multiplikationen gemacht werden.
    ZaehlerGNZ:=GNZeins;
    If Grenze<=N then
    begin
      setlength(ZwSpGNZ,1);
      for i:=N downto Grenze do
      begin
        ZwSpGNZ[0]:=i;
        ZaehlerGNZ:=GNZmul(ZwSpGNZ,ZaehlerGNZ);
      end;
    end; // If Grenze<=N then
    // Nenner berechnen
    Grenze:=N-K;
    NennerGNZ:=GNZeins;
    If Grenze>1 then
    begin
      setlength(ZwSpGNZ,1);
      for i:=Grenze downto 2 do
      begin
        ZwSpGNZ[0]:=i;
        NennerGNZ:=GNZmul(ZwSpGNZ,NennerGNZ);
      end;
    end; // If Grenze>1 then
    RESULT:=GNZdiv(ZaehlerGNZ,NennerGNZ);
  end else
  begin
    Err:=20;
    RESULT:=GNZeins;                                                              // Vorbeugung von Zugriffsfehlern
  end; // If K<=N then else
end; // GNZNüberK

function tAnalyse.GNZIstPrim(Zahl:GNZTyp):boolean;  // Deterministisch. Verwendet MillerRabinPrim: Dieser ist deterministisch, wenn alle Zeugen <2*(ln(zahl))^2 getestet werden.
var MaximalZeuge,Zeuge,ZwSp:dword;
begin
  If (length(Zahl)=1){and(Zahl[0]<341550071728321)} then                          // HINWEIS: Ausklammerung muss aufgehoben werden, falls der GNZTyp auf qword basiert. Aktuell basiert es auf dword, hier wird der ausgeklammerte Teil nicht benötigt.
  begin  // in diesem Fall ist MillerRabin fuer die Zeugen 2,3,5,7,11,13,17 deterministisch.
    If Zahl[0]<1000000 then RESULT := IstPrim(Zahl[0]) else
      RESULT:=(GNZMillerRabinPrim(Zahl,WordToGNZTyp(2)))and(GNZMillerRabinPrim(Zahl,WordToGNZTyp(3)))and(GNZMillerRabinPrim(Zahl,WordToGNZTyp(5)))and(GNZMillerRabinPrim(Zahl,WordToGNZTyp(7)))
               and(GNZMillerRabinPrim(Zahl,WordToGNZTyp(11)))and(GNZMillerRabinPrim(Zahl,WordToGNZTyp(13)))and(GNZMillerRabinPrim(Zahl,WordToGNZTyp(17)));
  end else
  begin
    //Berechnung von 2*(ln(Zahl))^2 :
    ZwSp:=length(Zahl)*ceil(ln(GNZ_GlobZahlenBasis));
    MaximalZeuge:=2*ZwSp*ZwSp;
    //Ale Primzahlen kleiner MaximalZeuge werden nun als Zeuge verwendet:
    Zeuge:=2;
    RESULT := true;
    while (Zeuge < MaximalZeuge)and(RESULT=true) do
    begin
      RESULT := GNZMillerRabinPrim(Zahl,WordToGNZTyp(Zeuge));
      Zeuge := PrimDanach(Zeuge);
    end; //while
  end; // If (length(Zahl)=1)and(Zahl[0]<341550071728321) ELSE
end; //GNZIstPrim


function tAnalyse.GNZPrimDanach(Zahl:GNZTyp):GNZTyp;
var n,eins,zwei:GNZTyp;
begin
  RESULT:=nil;
  eins:=GNZeins;
  zwei:=GNZadd(eins,eins);
  If GNZakleinerb(Zahl,zwei) then RESULT:=zwei else if GNZIstGerade(Zahl) then n:=GNZsub(Zahl,eins) else n:=copy(zahl);
  If RESULT=nil then
  begin
    If length(n)=1 then
    begin
      repeat
        n:=GNZadd(n,zwei);
      until GNZIstPrim(n);
    end else
    begin
      repeat
        n:=GNZadd(n,zwei);
      until GNZMillerRabinItera(n,25);
    end;
    RESULT:=n;
  end; // if RESULT=nil
end; // GNZPrimDanach


function tAnalyse.GNZPrimDavor(Zahl:GNZTyp):GNZTyp;
var n, eins, zwei:GNZTyp;
begin
  RESULT:=nil;
  eins:=GNZeins;
  zwei:=GNZadd(eins,eins);
  If GNZakleinerb(Zahl,3) then
  begin
    Err:=12;
    RESULT:=GNZeins;                                                              // Um Schwierigkeiten vorzubeugen, sollte RESULT nicht nil sein.
  end else if GNZagleichb(Zahl,3) then RESULT:=zwei else if GNZIstGerade(Zahl) then n:=GNZadd(Zahl,eins) else n:=copy(zahl);
  If RESULT=nil then
  begin
    If length(n)=1 then
    begin
      repeat
        n:=GNZsub(n,zwei);
      until (GNZIstPrim(n))or(GNZakleinerb(n,zwei));
    end else
    begin
      repeat
        n:=GNZsub(n,zwei);
      until (GNZMillerRabinItera(n,25))or(GNZakleinerb(n,zwei));
    end;
    If not GNZakleinerb(n,zwei) then RESULT:=n else Err:=12;
  end; // if RESULT=nil
end; // GNZPrimDavor


function tAnalyse.GNZPrimzahlListe(VonGNZ, BisGNZ:GNZTyp):GNZListeTyp;  // gibt NIL zurück, wenn keine Primzahl im Intervall vorhanden.
var PrimAnz:dword;
    zwei:GNZTyp;
begin
  PrimAnz:=0;
  RESULT:=nil;
  zwei:=WordToGNZTyp(2);
  If GNZakleinerb(VonGNZ,3) then
  begin  // Wenn VonGNZ<=2 ist, muss 2 als Primzahl hinzugefügt werden.
    inc(PrimAnz);
    setlength(RESULT,PrimAnz);
    RESULT[PrimAnz-1]:=copy(zwei);
  end;

  If GNZagleichb(GNZmod(VonGNZ,zwei),GNZnull) then VonGNZ:=GNZadd(VonGNZ,GNZeins);  // Lässt sich ggf. noch effektiver gestalten.
  If GNZakleinerb(BisGNZ,VonGNZ) then Err:=12 else
  begin
    repeat
      If GNZIstPrim(VonGNZ) then                                                    // HINWEIS: Kann durch Nutzung von Rabin-Miller-Prim für große Zahlen noch beschleunigt werden.
      begin
        inc(PrimAnz);
        setlength(RESULT,PrimAnz);
        RESULT[PrimAnz-1]:=copy(VonGNZ);
      end;
      VonGNZ:=GNZadd(VonGNZ,zwei);
    until GNZakleinerb(BisGNZ,VonGNZ);
  end; // If GNZakleinerb(BisGNZ,VonGNZ) then Err:=12 else
end; // GNZPrimzahlliste


function tAnalyse.GNZPrimFaktZerl(Zahl:GNZTyp):PTermTyp;
var Kopf, ZwSpPTT: PTermTyp;
    PrimFaktor, DivErg: GNZTyp;
    PrimExponent: dword;                                                            // aus Geschwindigkeitsgründen: Größere Exponenten als 2147483648 sind dann nicht mehr möglich, aber bei derzeitigen Rechnergeschwindigkeiten auch nicht vorstellbar.
    DivErgIstPrim: boolean;
begin  // Gibt Primfaktorzerlegung als Term aus: z.B. RESULT=2^3*5*11^2  - so kann sie direkt weiterverwendet werden.
  RESULT:=nil;
  If GNZakleinerb(Zahl,2) then
  begin
    Err:=12;
    new(RESULT);                                                                    // Vorbeugung von Zugriffsfehlern bei TermFreigabe
    RESULT^.Opera:=001;
    RESULT^.ZahlGRaZ:=GRaZeins;
  end;
  If RESULT=nil then
  begin
    // Initialisierung:
    new(RESULT);
    Kopf:=RESULT;                                                                   // Kopf zeigt jetzt auf selben Speicherbereich wie RESULT.
    ZwSpPTT:=nil;
    PrimFaktor:=GNZeins;                                                            // 1
    DivErgIstPrim:=false;
    DivErg:=copy(Zahl);
    //Primfaktorzerlegung:
    Repeat
      PrimFaktor:=GNZPrimDanach(PrimFaktor);
      If GNZagleichb(GNZmod(DivErg,PrimFaktor),0) then
      begin
        PrimExponent:=1;
        DivErg:=GNZdiv(DivErg,PrimFaktor);
        while GNZagleichb(GNZmod(DivErg,PrimFaktor),0) do
        begin
          inc(PrimExponent);
          DivErg:=GNZdiv(DivErg,PrimFaktor);
        end; // while
        If not (ZwSpPTT = nil) then
        begin // Folgend wird das Produkt zusammengesetzt.
          Kopf^.Opera:=005;
          Kopf^.Arg1:=ZwSpPTT;
          new(Kopf^.Arg2);
          Kopf:=Kopf^.Arg2;
        end; // If not (ZwSpPTT = nil)
        If PrimExponent=1 then
        begin // ZwSpPTT:=Primfaktor  (da PrimExponent=1)
          new(ZwSpPTT);
          ZwSpPTT^.Opera:=001;
          ZwSpPTT^.ZahlGRaZ.Zaehler:=PrimFaktor;
          ZwSpPTT^.ZahlGRaZ.Nenner :=GNZeins;
          ZwSpPTT^.ZahlGRaZ.Negativ:=false;
        end else
        begin // ZwspPTT := PrimFaktor^PrimExponent
          new(ZwSpPTT);
          ZwSpPTT^.Opera:=006;                                                      // = Potenz
          new(ZwSpPTT^.Arg1);
          ZwSpPTT^.Arg1^.Opera:=001;
          ZwSpPTT^.Arg1^.ZahlGRaZ.Zaehler:=PrimFaktor;                              // defensiver wäre mit copy... ... ist vermutlich aber nicht notwendig.
          ZwSpPTT^.Arg1^.ZahlGRaZ.Nenner :=GNZeins;
          ZwSpPTT^.Arg1^.ZahlGRaZ.Negativ:=false;
          new(ZwSpPTT^.Arg2);
          ZwSpPTT^.Arg2^.Opera:=001;
          ZwSpPTT^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(PrimExponent,1,false);             // PrimExponent/1, nichtnegativ
        end; // If PrimExponent=1 else
      end; // If (DivErg mod Primfaktor)=0
      If GNZIstPrim(DivErg) then DivErgIstPrim:=true;
    Until DivErgIstPrim or (GNZagleichb(DivErg,1));
    If DivErgIstPrim then
    begin
      If not (ZwSpPTT = nil) then
      begin // Folgend wird das Produkt zusammengesetzt.
        Kopf^.Opera:=005;
        Kopf^.Arg1:=ZwSpPTT;
        new(Kopf^.Arg2);
        Kopf:=Kopf^.Arg2;
      end; // If not (ZwSpPTT = nil)
      new(ZwSpPTT);
      ZwSpPTT^.Opera:=001;
      ZwSpPTT^.ZahlGRaZ.Zaehler:=DivErg;
      ZwSpPTT^.ZahlGRaZ.Nenner :=GNZeins;
      ZwSpPTT^.ZahlGRaZ.Negativ:=false;
    end; // If DivErgIstPrim
    Kopf^:=ZwSpPTT^;
    Dispose(ZwSpPTT);
  end; // If RESULT=nil
end; // GNZPrimFaktZerl


function tAnalyse.GNZMillerRabinPrim(zahl,zeuge:GNZTyp):boolean;             // Zahl muss ungerade sein; 1<Zeuge<Zahl; gibt true zurueck, wenn zahl Primkandidat
var Zminus,gerade,ungerade,j,r,null,eins,zwei,ZweierPotenz:GNZTyp;
begin  //Algorithmus nach Miller und Rabin.
  If (GNZIstGerade(Zahl))or(not GNZakleinerb(Zeuge,Zahl))or((length(Zeuge)=1)and(Zeuge[0]<=1)) then Err:=16 else
  begin
    null:=GNZnull; eins:=GNZeins; zwei:=GNZadd(eins,eins);                     // aus Gründen der Geschwindigkeit, damit Zahlen nicht immer neu erzeugt werden müssen.
    j :=GNZnull;                                                               // wegen Pointer darf nicht j:=null
    r :=GNZnull;
    ZweierPotenz:=copy(zwei);                                                  // Ein Vielfaches von 2.
    Zminus:=GNZsub(Zahl,eins);                                                 // = Zahl - 1
    //Die Zahl Zminus wird in einen geraden Faktor "gerade" und einen ungeraden Faktor "ungerade" zerlegt.
    while GNZagleichb(GNZmod(Zminus,ZweierPotenz),null) do
    begin
      j:=GNZadd(j,eins);                                                       // gerade = 2^j
      gerade:=copy(ZweierPotenz);                                              // Zum Einsparen von Rechenzeit: Dies ist am Ende der gerade Faktor
      ZweierPotenz:=GNZmulword(2,ZweierPotenz);
    end; //while
     ungerade := GNZdiv(Zminus,gerade);                                        // Nun ist: Zminus=gerade*ungerade; gerade = 2^j
   If not GNZagleichb(GNZPotenzModulo(zeuge,ungerade,zahl),eins) then
    begin
      RESULT:=false;
      repeat
        If GNZagleichb(GNZPotenzModulo(Zeuge,GNZmul(ungerade,GNZPotenz(zwei,r)),zahl),Zminus) then RESULT:=true;
        r:=GNZadd(r,eins);
      until (RESULT=true)or(GNZagleichb(r,j));
    end else RESULT:=true;
  end; // if not GNZIstGerade
end; // RabinMillerPrim


function tAnalyse.GNZMillerRabinItera(zahl:GNZTyp;itera:dword):boolean;
var n: integer;
    Prim:boolean;
    Zufallszahl:GNZTyp;
begin
  n:=0;
  repeat
    inc(n);
    repeat
      Zufallszahl:=GNZRandom(zahl);
    until not ((length(Zufallszahl)=0)and(Zufallszahl[0]<=1));
    Prim:=GNZMillerRabinPrim(zahl,Zufallszahl);
  until (n=itera) or (Prim=false);
  RESULT:=Prim;
end; // GNZMillerRabinItera


function tAnalyse.GNZRandom(OGrenze:GNZTyp):GNZTyp;
var n, ZwSp:dword;
begin
  setlength(RESULT,length(OGrenze));
  for n:=0 to length(OGrenze)-1 do RESULT[n]:=Random(OGrenze[n]);
  n:=length(RESULT)-1;
  ZwSp:=n;
  while (n>0)and(RESULT[n]=0) do dec(n);
  If n<ZwSp then setlength(RESULT,n+1);
end; // GNZRandom


//GNZ Basiswechsel-Funktionen---------------------------------------


function tAnalyse.GNZZbasiswechsel(QBasisWrd,ZBasisWrd:dword;Zahl:GNZTyp):GNZTyp;
var ZwErg, ZwSpGNZ, QBasis, ZBasis:GNZTyp;
    n:dword;
begin
  QBasis:=WordToGNZTyp(QBasisWrd);
  ZBasis:=WordToGNZTyp(ZBasisWrd);
  setlength(ZwSpGNZ,1);
  ZwErg:=GNZnull;
  for n:=length(Zahl)-1 downto 0 do                                            // Zunächst wird die Zahlenbasis von QBasis auf GNZ_GlobZahlenbasis transformiert
  begin
    ZwSpGNZ[0]:=Zahl[n];
    ZwErg:=GNZadd(GNZmul(ZwErg,QBasis),ZwSpGNZ);
  end;
  n:=0;
  repeat                                                                       // Dann wird die Zahlenbasis von GNZ_Globzahlenbasis auf ZBasis transformiert
    setlength(RESULT,n+1);
    RESULT[n]:=GNZmod(ZwErg,ZBasis)[0];
    ZwErg:=GNZdiv(ZwErg,ZBasis);
    inc(n);
  until (length(ZwErg)=1)and(ZwErg[0]=0);
end; //GNZZbasiswechsel


function tAnalyse.GNZBasisDezToGlobB(Zahl:GNZTyp):GNZTyp;
var Erg,BasisDez,ZwSpGNZ:GNZTyp;
    n:dword;
begin
  setlength(BasisDez,1);
  BasisDez[0]:=10;
  setlength(ZwSpGNZ,1);
  setlength(Erg,1);
  Erg[0]:=0;
  for n:=length(Zahl)-1 downto 0 do
  begin
    ZwSpGNZ[0]:=Zahl[n];
    Erg:=GNZadd(GNZmul(Erg,BasisDez),ZwSpGNZ);
  end;
  Result:=Erg;
end; // GNZBasisDezToGlobB


function tAnalyse.GNZGlobBToBasisDez(Zahl:GNZTyp):GNZTyp;
var Erg,BasisDez,ZwSpGNZ:GNZTyp;
    n:dword;
begin
  setlength(BasisDez,1);
  BasisDez[0]:=10;
  ZwSpGNZ:=copy(Zahl);
  n:=0;
  repeat
    setlength(Erg,n+1);
    Erg[n]:=GNZmod(ZwSpGNZ,BasisDez)[0];
    ZwSpGNZ:=GNZdiv(ZwSpGNZ,BasisDez);
    inc(n);
  until (length(ZwSpGNZ)=1)and(ZwSpGNZ[0]=0);
  Result:=Erg;
end; // GNZGlobBToBasisDez


function tAnalyse.WordToGNZTyp(WZahl:dword):GNZTyp;
var Erg:GNZTyp;
begin
  setlength(Erg,1);
  Erg[0]:=WZahl mod GNZ_GlobZahlenbasis;
  WZahl:=WZahl div GNZ_GlobZahlenbasis;
  If WZahl<>0 then
  begin
    setlength(Erg,2);
    Erg[1]:=WZahl;
  end;
  Result:=Erg;
end;  //WordToGNZTyp



//GRaZ-Operatonen - Rechnen mit grossen Rationalen Zahlen  ---------------------------------------------------


function tAnalyse.GRaZKuerzen(Bruch:GRaZTyp):GRaZTyp;
var ZwSpGNZ:GNZTyp;
begin
  //Eventuelles Kuerzen:
  If (length(Bruch.zaehler)=1)and(Bruch.zaehler[0]=0) then
  begin
    Result.zaehler :=GNZnull;
    Result.nenner  :=GNZeins;
    Result.Negativ :=false;
  end else
  begin
    ZwSpGNZ:=GNZggt(Bruch.nenner,Bruch.zaehler);
    If (length(ZwSpGNZ)=1)and(ZwSpGNZ[0]=1) then Result:=Bruch else
    begin
      Result.zaehler:=GNZdiv(Bruch.zaehler,ZwSpGNZ);
      Result.nenner:=GNZdiv(Bruch.nenner,ZwSpGNZ);
    end;
    Result.Negativ:=Bruch.Negativ;
  end;
end;  //GRaZKuerzen


function tAnalyse.GRaZadd(a,b:GRaZTyp):GRaZTyp;
var ZwSpGNZ:GNZTyp;
    Erg:GRaZTyp;
begin
  ZwSpGNZ:=GNZkgv(a.nenner,b.nenner);     //Brueche auf einen Nenner bringen...
  If a.Negativ=b.Negativ then
  begin
    Erg.nenner:=ZwSpGNZ;
    Erg.zaehler:=GNZadd(GNZmul(a.zaehler,GNZdiv(ZwSpGNZ,a.nenner)),GNZmul(b.zaehler,GNZdiv(ZwSpGNZ,b.nenner)));
    Erg.Negativ:=a.Negativ;
  end else
  if GRaZakleinerbBetrag(a,b) then
  begin
    Erg.nenner:=ZwSpGNZ;
    Erg.zaehler:=GNZsub(GNZmul(b.zaehler,GNZdiv(ZwSpGNZ,b.nenner)),GNZmul(a.zaehler,GNZdiv(ZwSpGNZ,a.nenner))); //b-a
    Erg.Negativ:=b.Negativ;
  end else
  begin
    Erg.nenner:=ZwSpGNZ;
    Erg.zaehler:=GNZsub(GNZmul(a.zaehler,GNZdiv(ZwSpGNZ,a.nenner)),GNZmul(b.zaehler,GNZdiv(ZwSpGNZ,b.nenner))); //a-b
    Erg.Negativ:=a.Negativ;
    If (length(Erg.zaehler)=1)and(Erg.zaehler[0]=0) then
    begin
      Erg.nenner:=GNZeins;
      Erg.Negativ:=false;
    end;
  end;
  Result:=GRaZKuerzen(Erg);
end; //GRaZadd


function tAnalyse.GRazsub(Minuent,Subtrahend:GRaZTyp):GRaZTyp;
begin
  Subtrahend.Negativ:=not Subtrahend.Negativ;
  Result:=GRaZadd(Minuent,Subtrahend);
end; //GRaZsub


function tAnalyse.GRaZmul(a,b:GRaZTyp):GRaZTyp;
var Erg:GRaZTyp;
begin
  Erg.zaehler:=GNZmul(a.zaehler,b.zaehler);
  Erg.nenner:=GNZmul(a.nenner,b.nenner);
  Erg.Negativ:= a.Negativ xor b.Negativ;
  Result:=GRaZKuerzen(Erg);
end; //GRaZmul


function tAnalyse.GRaZdiv(Divident,Divisor:GRaZTyp):GRaZTyp;
var Erg:GRaZTyp;
begin
  Erg.zaehler:=GNZmul(Divident.zaehler,Divisor.nenner);
  Erg.nenner:=GNZmul(Divident.nenner,Divisor.zaehler);
  Erg.Negativ:= Divident.Negativ xor Divisor.Negativ;
  Result:=GRaZKuerzen(Erg);
end; //GRaZdiv


function tAnalyse.GRaZakleinerbBetrag(a,b:GRaZTyp):boolean;
var ZwSpGNZ:GNZTyp;
begin
  ZwSpGNZ:=GNZkgv(a.nenner,b.nenner);
  Result:=GNZakleinerb(GNZmul(a.zaehler,GNZdiv(ZwSpGNZ,a.nenner)),GNZmul(b.zaehler,GNZdiv(ZwSpGNZ,b.nenner)));
end; //GRaZakleinerbBetrag


function tAnalyse.GRaZakleinerb(a,b:GRaZTyp):boolean;
var ZwSpGNZ:GNZTyp;
begin
  If (a.Negativ)and(not b.Negativ) then Result:=true else if (not a.Negativ)and(b.Negativ) then Result:=false
  else if (not a.Negativ)and(not b.Negativ) then
  begin
    ZwSpGNZ:=GNZkgv(a.nenner,b.nenner);
    Result:=GNZakleinerb(GNZmul(a.zaehler,GNZdiv(ZwSpGNZ,a.nenner)),GNZmul(b.zaehler,GNZdiv(ZwSpGNZ,b.nenner)));
  end else
  begin
    ZwSpGNZ:=GNZkgv(a.nenner,b.nenner);
    Result:=GNZakleinerb(GNZmul(b.zaehler,GNZdiv(ZwSpGNZ,b.nenner)),GNZmul(a.zaehler,GNZdiv(ZwSpGNZ,a.nenner)));
  end;
end; //GRaZakleinerb


function tAnalyse.GRaZagleichbBetrag(a,b:GRaZTyp):boolean;
var ZwSpGNZ:GNZTyp;
begin
  ZwSpGNZ:=GNZkgv(a.nenner,b.nenner);
  Result:=GNZagleichb(GNZmul(a.zaehler,GNZdiv(ZwSpGNZ,a.nenner)),GNZmul(b.zaehler,GNZdiv(ZwSpGNZ,b.nenner)));
end; //GRaZagleichbBetrag


function tAnalyse.GRaZagleichb(a,b:GRaZTyp):boolean;
var ZwSpGNZ:GNZTyp;
begin
  If a.Negativ=b.Negativ then
  begin
    ZwSpGNZ:=GNZkgv(a.nenner,b.nenner);
    Result:=GNZagleichb(GNZmul(a.zaehler,GNZdiv(ZwSpGNZ,a.nenner)),GNZmul(b.zaehler,GNZdiv(ZwSpGNZ,b.nenner)));
  end else Result:=false;
end; //GRaZagleichb


function tAnalyse.GRaZeins:GRaZTyp;
begin
  setlength(Result.zaehler,1);
  setlength(Result.nenner,1);
  Result.zaehler[0]:=1;
  Result.nenner[0]:=1;
  Result.Negativ:=false;
end; //GRaZeins


function tAnalyse.GRaZnull:GRaZTyp;
begin
  setlength(Result.zaehler,1);
  setlength(Result.nenner,1);
  Result.zaehler[0]:=0;
  Result.nenner[0]:=1;
  Result.Negativ:=false;
end; //GRaZnull


function tAnalyse.GRaZcopy(z:GRaZTyp):GRaZTyp;
begin
  RESULT.zaehler:=copy(z.zaehler);
  RESULT.nenner :=copy(z.nenner);
  RESULT.Negativ:=z.Negativ;
end;


function tAnalyse.WordToGRaZTyp(Zaehler,Nenner:dword;Negativ:boolean):GRaZTyp;
begin
  RESULT.zaehler:=WordToGNZTyp(Zaehler);
  RESULT.nenner :=WordToGNZTyp(Nenner);
  RESULT.Negativ:=Negativ;
end; // WordToGRaZTyp
