{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


unit UEinstellungen;

//Niemals OnChange-Ereignisse für Menüeinträge verwenden, da sonst das konzept mit CurrentSetToGui und CurrentGuiToSet nicht aufgeht
//Die Settings werden zuerst eingelesen, allerdings passiert schon davor ein on Change, sodass LocalSet geändert wird und nicht mehr Cur_Settings entspricht

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Buttons, Spin, Arrow, u_prm_Settings,
  uDrawClass,uPointEdit, math;

type

  { TFEinstellungen }

  TFEinstellungen = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    CB_AxisCross: TCheckBox;
    CB_distrFree: TCheckBox;
    CB_PrevCurv: TComboBox;
    CD_Options: TColorDialog;
    CB_dynamicGrid: TCheckBox;
    CG_TermOut: TCheckGroup;
    CB_Userdef_unit: TCheckBox;
    CB_DrwUSignRul: TCheckBox;
    CB_grad_bgrd: TComboBox;
    CB_grad_func: TComboBox;
    E_UnitSignX: TEdit;
    E_UnitSignY: TEdit;
    E_UnitValueX: TEdit;
    E_UnitValueY: TEdit;
    E_UnitNameX: TEdit;
    E_UnitNameY: TEdit;
    E_RulDensX: TEdit;
    E_RulDensY: TEdit;
    E_GridDens_x: TEdit;
    E_GridDens_y: TEdit;
    E_PinDens_x: TEdit;
    E_PinDens_y: TEdit;
    E_yMin: TEdit;
    E_xMin: TEdit;
    E_xMax: TEdit;
    E_yMax: TEdit;
    GB_RulCol: TGroupBox;
    GroupBox1: TGroupBox;
    GroupBox10: TGroupBox;
    GroupBox11: TGroupBox;
    GroupBox12: TGroupBox;
    GroupBox13: TGroupBox;
    GroupBox14: TGroupBox;
    GroupBox15: TGroupBox;
    GroupBox16: TGroupBox;
    GroupBox17: TGroupBox;
    GB_userdef_unit: TGroupBox;
    GB_Scale_Fonts: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    GroupBox9: TGroupBox;
    Img_RulVer_prev: TImage;
    Img_RulHor_prev: TImage;
    Img_Ico_prev: TImage;
    Img_Preview: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    L_scale_cross_font: TLabel;
    L_Scale_Stats_font: TLabel;
    L_Scale_rul_font: TLabel;
    LB_Literaly: TLabel;
    LB_Literalx: TLabel;
    LB_AAMode: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label3: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LB_ThreadCount: TLabel;
    LB_CurvWidth: TLabel;
    LB_unsharpnes: TLabel;
    LB_AA: TLabel;
    OD_Options: TOpenDialog;
    PC_Einstellungen: TPageControl;
    RG_rul: TRadioGroup;
    RG_DistrFree: TRadioGroup;
    SD_Options: TSaveDialog;
    SE_AA_hor: TSpinEdit;
    SE_AA_ver: TSpinEdit;
    SE_xOut: TSpinEdit;
    SE_YOut: TSpinEdit;
    SB_LoadSet: TSpeedButton;
    SB_saveSet: TSpeedButton;
    SB_PEdit: TSpeedButton;
    S_AxisCrossCol: TShape;
    S_RulTextCol: TShape;
    S_RulbgrdCol: TShape;
    S_CurvCol2: TShape;
    S_bgrdCol: TShape;
    S_bgrd2Col: TShape;
    S_CurvCol: TShape;
    S_PinCol: TShape;
    S_GridCol: TShape;
    S_AxisCol: TShape;
    SpeedButton1: TSpeedButton;
    SB_reset_Changes: TSpeedButton;
    SB_Session_only: TSpeedButton;
    SB_Default_Set: TSpeedButton;
    TB_unsharpnes: TTrackBar;
    TB_CurvWidth: TTrackBar;
    TB_ThreadCount: TTrackBar;
    TB_AA_Mode: TTrackBar;
    TB_Scale_rul_font: TTrackBar;
    TB_Scale_stats_font: TTrackBar;
    TB_Scale_Cross_font: TTrackBar;
    TS_Quality: TTabSheet;
    TS_ColSet: TTabSheet;
    TS_Window: TTabSheet;
    procedure CG_TermOutItemClick(Sender: TObject; Index: integer);
    procedure SB_PEditClick(Sender: TObject);
    procedure updateClick(Sender: TObject);
    procedure CB_PrevCurvKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MyOnExit(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MyOnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB_LoadSetClick(Sender: TObject);
    procedure SB_reset_ChangesClick(Sender: TObject);
    procedure SB_saveSetClick(Sender: TObject);
    procedure SB_Session_onlyClick(Sender: TObject);
    procedure SB_Default_SetClick(Sender: TObject);
    procedure SE_AA_horExit(Sender: TObject);
    procedure SE_AA_verExit(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure TB_AA_ModeChange(Sender: TObject);
    procedure TB_CurvWidthChange(Sender: TObject);
    procedure TB_Scale_Cross_fontChange(Sender: TObject);
    procedure TB_Scale_rul_fontChange(Sender: TObject);
    procedure TB_Scale_stats_fontChange(Sender: TObject);
    procedure TB_ThreadCountChange(Sender: TObject);
    procedure TB_unsharpnesChange(Sender: TObject);

  private
    { private declarations }
    LocalSet,PreviewSet:tGlobalSet;//LocalSet ist zum Bearbeiten da und wird zum Schluss zum Cur_Setting.
    Preview:tDrawClass;            //PreviewSet braucht man, weil die Auflösung zwischen der Preview und der Hauptimage sich stark unterscheiden
    SetLoadedToGui:Boolean;
    procedure CurrentSetToGui;
    procedure CurrentGuiToSet;
  public
    { public declarations }
  end; 

var
  FEinstellungen: TFEinstellungen;

implementation

uses uMain;

//Niemals OnChange-Ereignisse für Menüeinträge verwenden, da sonst das konzept mit CurrentSetToGui und CurrentGuiToSet nicht aufgeht
//Die Settings werden zuerst eingelesen, allerdings passiert schon davor ein OnChange, sodass LocalSet geändert wird und nicht mehr Cur_Settings entspricht

{ TFEinstellungen }

Procedure TFEinstellungen.CurrentSetToGui;
  begin
  If preview<>nil then begin
    //Color-Settings
    S_CurvCol.Brush.Color:=LocalSet.ColorSet.CurvCol;
    S_CurvCol2.Brush.Color:=LocalSet.ColorSet.CurvCol2;
    S_bgrdCol.Brush.Color:=LocalSet.ColorSet.bgrdCol;
    S_RulbgrdCol.Brush.Color:=LocalSet.ColorSet.RulbgrdCol;
    S_RulTextCol.Brush.Color:=Localset.ColorSet.RulTextCol;
    S_bgrd2Col.Brush.Color:=LocalSet.ColorSet.bgrdCol2;
    S_GridCol.Brush.Color:=LocalSet.ColorSet.GridCol;
    S_AxisCol.Brush.Color:=LocalSet.ColorSet.AxisCol;
    S_AxisCrossCol.Brush.Color:=LocalSet.ColorSet.AxisCrossCol;
    S_PinCol.Brush.Color:=LocalSet.ColorSet.PinCol;
    CB_Grad_bgrd.ItemIndex:=LocalSet.ColorSet.BgrdGrad+1;
    CB_Grad_func.ItemIndex:=LocalSet.ColorSet.CurvGrad+1;

    If LocalSet.Kartesianset.RulerMode=1 then GB_RulCol.Caption:='eigene Linealfarbe - aktiv' else  GB_RulCol.Caption:='eigene Linealfarbe - inaktiv';
    //Ende Color-Settings

    //FontSettings
    TB_Scale_rul_font.Position:=round((LocalSet.FontSet.RulFontScale-0.2)*10); L_Scale_rul_font.Caption:='Lineal: '+FloatToStr(round(LocalSet.FontSet.RulFontScale*10)/10);
    TB_Scale_stats_font.Position:=round((LocalSet.FontSet.StatsFontScale-0.2)*10); L_Scale_stats_font.Caption:='Statistik: '+FloatToStr(round(LocalSet.FontSet.StatsFontScale*10)/10);
    TB_Scale_cross_font.Position:=round((LocalSet.FontSet.AxisFontScale-0.2)*10); L_Scale_cross_font.Caption:='Kreuzchen: '+FloatToStr(round(LocalSet.FontSet.AxisFontScale*10)/10);
    //EndeFondSettings

    //Performance/Quality-Settings
    TB_ThreadCount.Position:=LocalSet.PerformanceSet.ThreadCount;
    LB_ThreadCount.Caption:=IntToStr(LocalSet.PerformanceSet.ThreadCount)+' Threads';
    SE_AA_hor.Value:=LocalSet.PerformanceSet.AA_Level_hor;
    SE_AA_ver.Value:=LocalSet.PerformanceSet.AA_Level_ver;
    LB_AA.Caption:=IntToStr(LocalSet.PerformanceSet.AA_Level_hor*LocalSet.PerformanceSet.AA_Level_ver)+'x AA';
    TB_CurvWidth.Position:=round(LocalSet.PerformanceSet.CurvWidth*10-5);
    LB_CurvWidth.Caption:=FloatToStr(Round(LocalSet.PerformanceSet.CurvWidth*10)/10)+' Pixel';
    If LocalSet.PerformanceSet.unsharpnes>0 then TB_Unsharpnes.Position:=round((ln(LocalSet.PerformanceSet.unsharpnes)-ln(8.2E-5))/(ln(10)*0.084746)) else TB_Unsharpnes.Position:=0;
    If LocalSet.PerformanceSet.unsharpnes>0 then LB_Unsharpnes.Caption:=FloatToStr(round(LocalSet.PerformanceSet.unsharpnes*100000)/100000)+' Pixel/Schritt' else LB_Unsharpnes.Caption:='dynamisch';
    TB_AA_Mode.Position:=LocalSet.PerformanceSet.AA_Mode;

    Case TB_AA_Mode.Position of
      1: LB_AAMode.Caption:='ungepuffertes Tetragon (max. 255xAA)';
      2: LB_AAMode.Caption:='gepuffertes Hexagon (max. 64xAA)';
      3: LB_AAMode.Caption:='gepufferter Kreis (max. 64xAA)';
      4: LB_AAMode.Caption:='gepuffertes Rundeck (max. 64xAA)';
    end;

    SE_xOut.Value:=LocalSet.PerformanceSet.TermkoordX;
    SE_yOut.Value:=LocalSet.PerformanceSet.TermkoordY;
    //Ende Performance/Quality-Settings

    //Kartesische Einstellungen



    If LocalSet.Kartesianset.dynamicGrid then begin
      E_GridDens_X.Enabled:=false; E_GridDens_Y.Enabled:=false; E_RulDensX.Enabled:=false; E_RulDensY.Enabled:=false;
    end else begin
      E_GridDens_X.Enabled:=true; E_GridDens_Y.Enabled:=true; E_RulDensX.Enabled:=true; E_RulDensY.Enabled:=true;
    end;

    If LocalSet.Kartesianset.UseUsrDefUnits then begin
      E_UnitSignX.Enabled:=true; E_UnitSignY.Enabled:=true; E_UnitValueX.Enabled:=true; E_UnitValueY.Enabled:=true; E_UnitNameX.Enabled:=true; E_UnitNameY.Enabled:=true; CB_DrwUSignRul.Enabled:=true;
    end else begin
      E_UnitSignX.Enabled:=false; E_UnitSignY.Enabled:=false; E_UnitValueX.Enabled:=false; E_UnitValueY.Enabled:=false; E_UnitNameX.Enabled:=false; E_UnitNameY.Enabled:=false; CB_DrwUSignRul.Enabled:=false;
    end;



    E_Xmin.Text:=FloatToStr(LocalSet.Kartesianset.xmin);
    E_XMax.text:=FloatToStr(LocalSet.Kartesianset.xmax);
    E_Ymin.text:=FloatToStr(LocalSet.Kartesianset.ymin);
    E_Ymax.text:=FloatToStr(LocalSet.Kartesianset.ymax);
    E_RulDensX.Text:=FloatToStr(LocalSet.Kartesianset.Ruldens_X);
    E_RulDensY.Text:=FloatToStr(LocalSet.Kartesianset.Ruldens_Y);
    E_GridDens_X.Text:=FloatToStr(LocalSet.Kartesianset.GridDensX);
    E_GridDens_Y.Text:=FloatToStr(LocalSet.Kartesianset.GridDensY);
    E_PinDens_X.Text:=FloatToStr(LocalSet.Kartesianset.PinSubDensX);
    E_PinDens_Y.Text:=FloatToStr(LocalSet.Kartesianset.PinSubDensY);
    E_UnitSignX.Text:=LocalSet.Kartesianset.UnitSignX;
    E_UnitSignY.Text:=LocalSet.Kartesianset.UnitSignY;
    E_UnitValueX.Text:=FloatToStr(LocalSet.Kartesianset.UnitValueX);
    E_UnitValueY.Text:=FloatToStr(LocalSet.Kartesianset.UnitValueY);
    E_UnitNameX.Text:=LocalSet.Kartesianset.UnitNameX;
    E_UnitNameY.Text:=LocalSet.Kartesianset.UnitNameY;

    RG_Rul.ItemIndex:=LocalSet.Kartesianset.RulerMode+1;
    If LocalSet.Kartesianset.RulerMode>-1 then begin
      FEinstellungen.Img_Ico_prev.Visible:=true;
      FEinstellungen.Img_RulHor_prev.Visible:=true;
      FEinstellungen.Img_RulVer_prev.Visible:=true;
    end else begin
      FEinstellungen.Img_Ico_prev.Visible:=false;
      FEinstellungen.Img_RulHor_prev.Visible:=false;
      FEinstellungen.Img_RulVer_prev.Visible:=false;
    end;
    //Ende kartesische Einstellungen

    //CBs Performance            //Bug: nachdem eine Checkbox innerhalb eines Tabs gesetzt wurde, werden keine Trackbars mehr bewegt, daher CBs immer ans ende des Sektors stellen
    Case LocalSet.PerformanceSet.TermOut of
     -1:begin CG_TermOut.Checked[0]:=false; CG_TermOut.Checked[1]:=false end;
     0:begin CG_TermOut.Checked[0]:=true; CG_TermOut.Checked[1]:=false end;
     1:begin CG_TermOut.Checked[0]:=false; CG_TermOut.Checked[1]:=true end;
     2:begin CG_TermOut.Checked[0]:=true; CG_TermOut.Checked[1]:=true end;
    end;

    CG_TermOut.Checked[2]:=LocalSet.PerformanceSet.statistics;

    //CBs kartesisch
    CB_AxisCross.Checked:=LocalSet.Kartesianset.AxisSign;
    CB_dynamicGrid.Checked:=LocalSet.Kartesianset.dynamicGrid;
    CB_UserDef_Unit.Checked:=LocalSet.Kartesianset.UseUsrDefUnits;
    CB_DrwUSignRul.Checked:=LocalSet.Kartesianset.DrwUSignRul;
    If LocalSet.Kartesianset.DistortFree>-1 then begin
      CB_distrFree.Checked:=true;
      RG_Distrfree.ItemIndex:=LocalSet.Kartesianset.DistortFree
    end else
      CB_distrFree.Checked:=false;

    //Vorschau-Funktion muss zuletzt stehen, damit alle Änderungen mit einfließen!

      PreviewSet:=LocalSet;
      PreViewSet.MainSizing.DrawResX:=FEinstellungen.Img_Preview.Width;
      PreViewSet.MainSizing.DrawResY:=FEinstellungen.Img_Preview.Height;
      Preview.SetDrawEnv2D(CB_PrevCurv.text,PreviewSet);
      Preview.Bildrueckgabe(Img_Preview);
      Preview.Linealrueckgabe(Img_RulHor_prev,Img_RulVer_prev,Img_Ico_prev);
      SetLoadedToGui:=true;
    end;
  end;

Procedure TFEinstellungen.CurrentGuiToSet;
  begin
  If (preview<>nil)and(SetLoadedToGui=true) then begin
    //Color-Settings
    LocalSet.ColorSet.CurvCol:=S_CurvCol.Brush.Color;
    LocalSet.ColorSet.CurvCol2:=S_CurvCol2.Brush.Color;
    LocalSet.ColorSet.bgrdCol:=S_BgrdCol.Brush.Color;
    LocalSet.ColorSet.bgrdCol2:=S_bgrd2Col.Brush.Color;
    LocalSet.ColorSet.gridCol:=S_GridCol.Brush.Color;
    LocalSet.ColorSet.AxisCol:=S_AxisCol.Brush.Color;
    LocalSet.ColorSet.AxisCrossCol:=S_AxisCrossCol.Brush.Color;
    LocalSet.ColorSet.PinCol:=S_PinCol.Brush.Color;
    LocalSet.ColorSet.RulbgrdCol:=S_RulBgrdCol.Brush.Color;
    LocalSet.ColorSet.RulTextCol:=S_RulTextCol.Brush.Color;
    LocalSet.ColorSet.BgrdGrad:=CB_Grad_bgrd.ItemIndex-1;
    LocalSet.ColorSet.CurvGrad:=CB_Grad_func.ItemIndex-1;
    //Ende Color-Settings

    //Font-Einstellungen
    LocalSet.FontSet.RulFontScale:=TB_Scale_rul_font.Position*0.1+0.2;
    LocalSet.FontSet.StatsFontScale:=TB_Scale_stats_font.Position*0.1+0.2;
    LocalSet.FontSet.axisFontScale:=TB_Scale_cross_font.Position*0.1+0.2;
    //Ende Fontsettings

    //Performance/Quality-Settings
    LocalSet.PerformanceSet.ThreadCount:=TB_ThreadCount.Position;
    LocalSet.PerformanceSet.AA_Level_hor:=SE_AA_hor.value;
    LocalSet.PerformanceSet.AA_Level_ver:=SE_AA_ver.value;
    LocalSet.PerformanceSet.CurvWidth:=TB_CurvWidth.Position/10+0.5;
    If TB_Unsharpnes.Position>0 then LocalSet.PerformanceSet.unsharpnes:=8.2E-5*power(10,0.084746*TB_Unsharpnes.Position) else LocalSet.PerformanceSet.unsharpnes:=0;
    LocalSet.PerformanceSet.statistics:=CG_TermOut.Checked[2];
    LocalSet.PerformanceSet.AA_Mode:=TB_AA_Mode.position;

    LocalSet.PerformanceSet.TermOut:=-1;
    If CG_TermOut.Checked[0]=true then Inc(LocalSet.PerformanceSet.TermOut,1);
    If CG_TermOut.Checked[1]=true then Inc(LocalSet.PerformanceSet.TermOut,2);

    LocalSet.PerformanceSet.TermkoordX:=SE_xOut.Value;
    LocalSet.PerformanceSet.TermKoordY:=SE_yOut.Value;
    //Ende Performance/Quality-Settings

    //kartesische Einstellungen
    LocalSet.Kartesianset.dynamicGrid:=CB_dynamicGrid.Checked;
    LocalSet.Kartesianset.UseUsrDefUnits:=CB_UserDef_Unit.checked;
    LocalSet.Kartesianset.DrwUSignRul:=CB_DrwUSignRul.Checked;
    LocalSet.Kartesianset.RulerMode:=RG_rul.ItemIndex-1;

    If CB_distrFree.Checked=false then LocalSet.Kartesianset.DistortFree:=-1
      else LocalSet.Kartesianset.DistortFree:=RG_DistrFree.ItemIndex;

    LocalSet.Kartesianset.AxisSign:=CB_AxisCross.Checked;
    Try    //Sichtbarer Bereich
      If (StrToFloat(E_Xmin.text)<StrToFloat(E_Xmax.text))and(StrToFloat(E_Ymin.text)<StrToFloat(E_Ymax.text)) then begin
        LocalSet.Kartesianset.xmin:=StrToFloat(E_Xmin.text);
        LocalSet.Kartesianset.xmax:=StrToFloat(E_Xmax.text);
        LocalSet.Kartesianset.yMin:=StrToFloat(E_Ymin.text);
        LocalSet.Kartesianset.Ymax:=StrToFloat(E_Ymax.text);
        LocalSet:=prm_Setmanager.change_viewRange(LocalSet);
      end else MessageDlg('*Eingabefehler*','Es wird nichts geändert, da mindestens ein Minimalwert größer ist als der entsprechende Maximalwert', mtError, [mbOk] , 0);
    except
      MessageDlg('*Eingabefehler*','In die Felder zur Bestimmung des Sichtbereichs sind ausschließlich reele Zahlen einzutragen!', mtError, [mbOk] , 0);
    end;
    Try    //Dichte-Einstellungen
      If (StrToFloat(E_GridDens_X.text)>=0)and(StrToFloat(E_RulDensX.text)>=0)and(StrToFloat(E_RulDensX.text)>=0)and(StrToFloat(E_GridDens_Y.text)>=0)and(StrToFloat(E_PinDens_X.text)>=0)and(StrToFloat(E_PinDens_Y.text)>=0) then begin
        LocalSet.Kartesianset.Ruldens_X:=StrToFloat(E_RulDensX.text);
        LocalSet.Kartesianset.Ruldens_Y:=StrToFloat(E_RulDensY.text);
        LocalSet.Kartesianset.GridDensX:=StrToFloat(E_GridDens_X.text);
        LocalSet.Kartesianset.GridDensY:=StrToFloat(E_GridDens_Y.text);
        LocalSet.Kartesianset.PinSubDensX:=StrToFloat(E_PinDens_x.text);
        LocalSet.Kartesianset.PinSubDensY:=StrToFloat(E_PinDens_y.text);
      end else MessageDlg('*Eingabefehler*','Gitternetz-Dichte und die Teilstrich-Subdichte müssen größer oder gleich 0 sein!', mtError, [mbOk] , 0);
    except
      MessageDlg('*Eingabefehler*','In die Felder zur Bestimmung der Koordinatensystemeinteilung sind ausschließlich positive reele Zahlen einzutragen!', mtError, [mbOk] , 0);
    end;
    Try
      If (StrToFloat(E_UnitValueX.Text)>0)and(StrToFloat(E_UnitValueY.Text)>0) then begin
        LocalSet.Kartesianset.UnitValueX:=StrToFloat(E_UnitValueX.Text);
        LocalSet.Kartesianset.UnitValueY:=StrToFloat(E_UnitValueY.Text);
      end else MessageDlg('*Eingabefehler*','Wertigkeiten müssen größer als 0 sein!', mtError, [mbOk] , 0);
      LocalSet.Kartesianset.UnitSignX:=E_UnitSignX.text;
      LocalSet.Kartesianset.UnitSignY:=E_UnitSignY.text;
      LocalSet.Kartesianset.UnitNameX:=E_UnitNameX.text;
      LocalSet.Kartesianset.UnitNameY:=E_UnitNameY.text;
    except
      MessageDlg('*Eingabefehler*','Die Wertigkeiten müssen reele Zahlen >0 sein!', mtError, [mbOk] , 0);
    end;

    //Ende kartesische Einstellungen

    end;
  end;


procedure TFEinstellungen.FormCreate(Sender: TObject);
begin
  Decimalseparator:=',';
  SetLoadedToGui:=false;
  LocalSet:=UMain.Cur_Settings;
end;

procedure TFEinstellungen.FormShow(Sender: TObject);
 var
   FMainRatio:double;
begin
  {$ifdef linux}
    Feinstellungen.Font.Size:=9;
    Feinstellungen.Color:=rgbToColor(240,240,240);
    Feinstellungen.PC_Einstellungen.Color:=clWhite;
  {$endif}
  FMainRatio:=Cur_Settings.MainSizing.DrawResX/Cur_Settings.MainSizing.DrawResY;
  If FMainRatio>=1then begin
    FEinstellungen.Img_Preview.width:=180;
    FEinstellungen.Img_Preview.picture.bitmap.width:=180;
    FEinstellungen.Img_Preview.Height:=round(FEinstellungen.Img_Preview.width/FMainRatio);
    FEinstellungen.Img_Preview.Picture.Bitmap.Height:=round(FEinstellungen.Img_Preview.width/FMainRatio);
  end else begin
    FEinstellungen.Img_Preview.width:=round(FEinstellungen.Img_Preview.height*FMainRatio);
    FEinstellungen.Img_Preview.picture.bitmap.width:=round(FEinstellungen.Img_Preview.height*FMainRatio);
    FEinstellungen.Img_Preview.Height:=180;
    FEinstellungen.Img_Preview.Picture.Bitmap.Height:=180;
  end;
  FEinstellungen.Img_Preview.Top:=76;
  FEinstellungen.Img_Preview.left:=560;

  with Feinstellungen.Img_RulHor_prev do begin
    Top:=FEinstellungen.Img_Preview.Top+FEinstellungen.Img_Preview.Height+1;
    left:=FEinstellungen.Img_Preview.left;
    width:=FEinstellungen.Img_Preview.Width;
    height:=12;//*Cur_Settings.FontSet.RulFontScale;
    picture.Bitmap.Width:=FEinstellungen.Img_Preview.Width;
    picture.Bitmap.Height:=height;
  end;
  with Feinstellungen.Img_RulVer_prev do begin
    Top:=FEinstellungen.Img_Preview.Top;
    left:=FEinstellungen.Img_Preview.left-13;
    width:=12;//*Cur_Settings.FontSet.RulFontScale);
    height:=FEinstellungen.Img_Preview.Height;
    picture.Bitmap.Width:=width;
    picture.Bitmap.Height:=FEinstellungen.Img_Preview.Height;
  end;
  with Feinstellungen.Img_Ico_prev do begin
    Top:=Feinstellungen.Img_RulHor_prev.Top;
    left:=Feinstellungen.Img_RulVer_prev.left;
    width:=12;
    height:=12;
    picture.Bitmap.Width:=12;
    picture.Bitmap.Height:=12;
  end;
  Preview:=tDrawClass.create;
  CurrentSetToGui;
end;

procedure TFEinstellungen.MyOnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If Sender.ClassType = tTrackbar then begin
    CurrentGuiToSet;
    CurrentSetToGui;
  end;

  If Sender.ClassType = tShape then begin
    CD_Options.Color:= tShape(Sender).Brush.Color;
    if CD_Options.Execute=true then begin
      tShape(Sender).Brush.Color:=CD_Options.Color;
      CurrentGuiToSet;
      CurrentSetToGui;
    end;
  end;

  If Sender.Classtype = tSpinEdit then begin
    CurrentGuiToSet;
    CurrentSetToGui;
  end;
end;

procedure TFEinstellungen.SB_LoadSetClick(Sender: TObject);
begin
  OD_Options.Filter:='Einstellungsdatei (*.ini)|*.ini';
  OD_Options.DefaultExt:='.ini';
  if OD_Options.Execute=true then begin
    if OD_Options.FileName<>'' then begin
      prm_setmanager.LoadIniToGlobalSet(LocalSet,OD_Options.FileName);
      CurrentSetToGui;
    end;
  end;
end;

procedure TFEinstellungen.SB_reset_ChangesClick(Sender: TObject);
begin
  LocalSet:=Cur_Settings;
  CurrentSetToGui;
end;

procedure TFEinstellungen.SB_saveSetClick(Sender: TObject);
begin
  SD_Options.Filter:='Einstellungsdatei (*.ini)|*.ini';
  SD_Options.DefaultExt:='.ini';
  if SD_Options.Execute=true then begin
    if SD_Options.FileName<>'' then begin
      prm_setmanager.SaveGlobalSetToIni(LocalSet,SD_Options.FileName);
    end;
  end;
end;

procedure TFEinstellungen.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  If Preview<>nil then begin
    PreView.free;
    PreView:=nil;
  end;
end;


procedure TFEinstellungen.updateClick(Sender: TObject);
begin
  CurrentGuiToSet;
  CurrentSetToGui;
end;

procedure TFEinstellungen.CG_TermOutItemClick(Sender: TObject; Index: integer);
begin
  CurrentGuiToSet;
  CurrentSetToGui;
end;

procedure TFEinstellungen.SB_PEditClick(Sender: TObject);
begin
  FPointEdit:=tFPointEdit.Create(2,CB_PrevCurv.Text);
  FPointEdit.showmodal;
  FPointEdit.free;
end;

procedure TFEinstellungen.CB_PrevCurvKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If (key = 13) and (CB_PrevCurv.Text<>'') then begin
     key:= 0; //beep abschalten
     CurrentSetToGui;
  end;
end;

procedure TFEinstellungen.MyOnExit(Sender: TObject);
begin
  If (Sender.ClassType=tEdit)or(Sender.ClassType=tSpinEdit) then begin
    CurrentGuiToSet;
    CurrentSetToGui;
  end;

  If Sender = CB_PrevCurv then CurrentSetToGui;
end;


procedure TFEinstellungen.SB_Session_onlyClick(Sender: TObject);
begin
  Application.ProcessMessages;
  CurrentGuiToSet;
  Prm_Setmanager.BackupSettings(FMain.MM_opt_source_Main.Checked,UMain.Cur_Settings);
  UMain.Cur_Settings:=LocalSet;
  FEinstellungen.Color:=clgreen;
  FEinstellungen.Repaint;
  FEinstellungen.Enabled:=false;
  FMain.updateGraph;
  FEinstellungen.ModalResult:=mrOK;  //Bug: Wenn Close vor updateGraph kommt, stützt es MANCHMAL ab, umso warscheinlicher, je mehr gerechnet werden muss
end;

procedure TFEinstellungen.SB_Default_SetClick(Sender: TObject);
begin
  LocalSet:=prm_Setmanager.get_Defaults; //Bei defaults werden auch Fenstergröße und Imageauflösung vorgegeben, daher die nächste Zeile.
  LocalSet.MainSizing:=Cur_Settings.MainSizing; //Die Bildschirmgröße soll sich nicht ändern.
  CurrentSetToGui;
end;

procedure TFEinstellungen.SE_AA_horExit(Sender: TObject);
 var
   Buf_h,buf_v:word;
begin
  try
    buf_h:=SE_AA_hor.value;
    buf_v:=SE_AA_ver.value;
    If LocalSet.PerformanceSet.AA_Mode=1 then begin
      If (buf_h<256) and (buf_v<256) then begin
        If buf_h*buf_v>255 then buf_v:=trunc(255/buf_h);
      end;
      SE_AA_ver.value:=buf_v;
    end;
    If LocalSet.PerformanceSet.AA_Mode>1 then begin
      If buf_h>64 then buf_h:=64;
      If buf_h*buf_v>64 then buf_v:=trunc(64/buf_h);
      SE_AA_ver.value:=buf_v;
      SE_AA_hor.Value:=buf_h;
    end;
  except
    SE_AA_hor.value:=1;
  end;
  CurrentGuiToSet;
  CurrentSetToGui;
end;

procedure TFEinstellungen.SE_AA_verExit(Sender: TObject);
 var
   Buf_h,buf_v:word;
begin
  try
    buf_h:=SE_AA_hor.value;
    buf_v:=SE_AA_ver.value;
    If LocalSet.PerformanceSet.AA_Mode=1 then begin
      If (buf_h<256) and (buf_v<256) then begin
        If buf_h*buf_v>255 then buf_h:=trunc(255/buf_v);
      end;
      SE_AA_hor.value:=buf_h;
    end;
    If LocalSet.PerformanceSet.AA_Mode>2 then begin
      If buf_v>64 then buf_v:=64;
      If buf_h*buf_v>64 then buf_h:=trunc(64/buf_v);
      SE_AA_hor.value:=buf_h;
      SE_AA_ver.Value:=buf_v;
    end;
  except
    SE_AA_ver.value:=1;
  end;
  CurrentGuiToSet;
  CurrentSetToGui;
end;

procedure TFEinstellungen.SpeedButton1Click(Sender: TObject);
begin
  prm_SetManager.LoadIniToGlobalSet(LocalSet,'defaults.ini');
  CurrentSetToGui;
end;


procedure TFEinstellungen.TB_AA_ModeChange(Sender: TObject);
var
  ratio:double;
  buf:longInt;
begin
  If Preview<>nil then begin
    Case TB_AA_Mode.Position of
      1: LB_AAMode.Caption:='ungepuffertes Tetragon (max. 255xAA)';
      2..4: begin
             buf:=SE_AA_hor.Value*SE_AA_ver.Value;
             if buf>64 then begin
               Ratio:=64/buf;
               SE_AA_Hor.Value:=trunc(SE_AA_Hor.Value*Sqrt(Ratio));
               SE_AA_Ver.Value:=trunc(SE_AA_Ver.Value*Sqrt(Ratio));
             end;
             Case TB_AA_Mode.Position of
               2:LB_AAMode.Caption:='gepuffertes Hexagon (max. 64xAA)';
               3:LB_AAMode.Caption:='gepufferter Kreis (max. 64xAA)';
               4:LB_AAMode.Caption:='gepuffertes Rundeck (max. 64xAA)';
             end;
      end;
    end;
  end;
end;


procedure TFEinstellungen.TB_CurvWidthChange(Sender: TObject);
begin
  If Preview<>nil then LB_CurvWidth.Caption:= FloatToStr(round((TB_CurvWidth.Position/10+0.5)*10)/10);
end;


procedure TFEinstellungen.TB_Scale_Cross_fontChange(Sender: TObject);
begin
  If Preview<>nil then L_Scale_cross_font.Caption:='Kreuzchen: '+FloatToStr(TB_Scale_cross_font.Position*0.1+0.2);
end;

procedure TFEinstellungen.TB_Scale_rul_fontChange(Sender: TObject);
begin
  If Preview<>nil then L_Scale_rul_font.Caption:='Lineal: '+FloatToStr(TB_Scale_rul_font.Position*0.1+0.2);
end;


procedure TFEinstellungen.TB_Scale_stats_fontChange(Sender: TObject);
begin
  If Preview<>nil then L_Scale_stats_font.Caption:='Statistik: '+FloatToStr(TB_Scale_stats_font.Position*0.1+0.2);
end;

procedure TFEinstellungen.TB_ThreadCountChange(Sender: TObject);
begin
  If Preview<>nil then LB_ThreadCount.Caption:=IntToStr(TB_ThreadCount.Position);
end;

procedure TFEinstellungen.TB_unsharpnesChange(Sender: TObject);
begin
  If Preview<>nil then
    if TB_unsharpnes.Position>0 then LB_Unsharpnes.Caption:= FloatToStr(round(8.2E-5*power(10,0.084746*TB_Unsharpnes.Position)*100000)/100000)
      else LB_unsharpnes.Caption:='dynamisch';
end;



initialization
  {$I ueinstellungen.lrs}

end.

