unit uEqEdit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Grids, Spin, StdCtrls, Buttons,u_prm_numerik;

type

  { TFEqEdit }

  TFEqEdit = class(TForm)
    L_EqSize: TLabel;
    OD_Eq: TOpenDialog;
    SD_Eq: TSaveDialog;
    SG_Eq: TStringGrid;
    SB_EqSize: TSpeedButton;
    SB_SolveEq: TSpeedButton;
    SB_SaveEq: TSpeedButton;
    SE_EqSize: TSpinEdit;
    SB_LoadEq: TSpeedButton;
    SB_EqReset: TSpeedButton;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SB_EqSizeClick(Sender: TObject);
    procedure SB_LoadEqClick(Sender: TObject);
    procedure SB_SaveEqClick(Sender: TObject);
    procedure SB_SolveEqClick(Sender: TObject);
    procedure SE_EqSizeClick(Sender: TObject);
    procedure SE_EqSizeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SG_EqClick(Sender: TObject);
    procedure SG_EqDrawCell(Sender: TObject; aCol, aRow: Integer; aRect: TRect;
      aState: TGridDrawState);
    procedure SG_EqSelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
    procedure SB_EqResetClick(Sender: TObject);
  private
    { private declarations }
    EqSize:dWord;
    GuiFrozen:boolean;
    Numerik:tNumerik;
    FoundErrors:array[1..5]of boolean;
    procedure SetGui(freeze:boolean);
    function GuiToGlsys:tGlSys;
    function prepareOpenGlsys(NameOrPath:utf8string):dWord;     //gibt RowCount Zurück, falls alles klappt.
    procedure showResults(Glsys:tGlSys);
  public
    { public declarations }
  end; 

var
  FEqEdit: TFEqEdit;

implementation

{ TFEqEdit }

procedure TFEqEdit.SetGui(freeze: boolean);
 var
   loc_EqSize,IntBuf:dword;                  //Größe des Gleichungssystems
   sX,sY:dword;                          //erforderliche Client-Größe des Fensters für optimale Darstellung

 const
   yGenGap=6; xScrGap=120; yScrGap=180; rightColWidth=86;
  begin
    If not GuiFrozen then begin
      //Anfangswerte Setzen
      loc_EqSize:=SE_EqSize.Value;
      sX:=2*SG_Eq.Left+SG_Eq.DefaultColWidth*(loc_EqSize+1)+rightColWidth;
      sY:=2*SG_Eq.Top+SG_Eq.DefaultRowHeight*(loc_EqSize+3)+L_EqSize.Height+SE_EqSize.Height+3*yGenGap;
      //Prüfung, ob Darstellung ohne Scrollbars möglich und Maßnahmen einleiten, falls nicht
      If sX>Screen.Width-xScrGap-(FEqEdit.Width-FEqEdit.ClientWidth) then begin
        IntBuf:=Screen.Width-xScrGap-(FEqEdit.Width-FEqEdit.ClientWidth)-2*SG_Eq.Left;
        SG_Eq.Width:=IntBuf;
        sX:=Screen.Width-xScrGap-(FEqEdit.Width-FEqEdit.ClientWidth);
      end else SG_Eq.width:=(Loc_EqSize+1)*SG_Eq.DefaultColWidth+rightColWidth+1;
      FEqEdit.ClientWidth:=sX;
      If sY>Screen.Height-yScrGap-(FEqEdit.Height-FEqEdit.ClientHeight) then begin
        IntBuf:=Screen.Height-yScrGap-(FEqEdit.Height-FEqEdit.ClientHeight)-2*SG_Eq.Top-3*yGenGap-L_EqSize.Height-SE_EqSize.Height;
        SG_Eq.Height:=IntBuf;
        sY:=Screen.Height-yScrGap-(FEqEdit.Height-FEqEdit.ClientHeight);
      end else SG_Eq.Height:=(loc_EqSize+3)*SG_Eq.DefaultRowHeight+1;
      FEqEdit.ClientHeight:=sY;
      //Ausrichten der Bedienelemente an den StringGrids
      SB_LoadEq.Top:=SG_Eq.Top+SG_Eq.Height+yGenGap;
      SB_EqReset.Top:=SB_LoadEq.Top;
      L_EqSize.Top:=SB_LoadEq.Top+6;
      SE_EqSize.Top:=SB_LoadEq.Top+SB_LoadEq.Height+yGenGap;
      SB_EqSize.Top:=SE_EqSize.Top;
      SB_SolveEq.Top:=SE_EqSize.Top;
      SB_SaveEq.Top:=SE_EqSize.Top;
      //StringGrid auf richtige Größe, Spalten- und Zeilenanzahl bringen und feste Werte eintragen
      With SG_Eq do begin
        ColCount:=1; RowCount:=1; ColWidths[0]:=DefaultColWidth;                     //Reset des StringGrids
        ColCount:=loc_EqSize+2; RowCount:=loc_EqSize+3;                                      //Anzahl Felder des StringGrids setzen
        ColWidths[ColCount-1]:=rightColWidth; Cells[ColCount-1,0]:='(=)Ergebnisse';   //Rechte Spalte des StringGrids setzen.
        Cells[0,RowCount-2]:='Lösungen';
      end;
      //StringGrid mit variablen Werten füllen.
      For IntBuf:=1 to SG_Eq.RowCount-3 do SG_Eq.Cells[0,IntBuf]:='Gl. '+IntToStr(IntBuf);
      For IntBuf:=1 to SG_Eq.ColCount-2 do begin
        SG_Eq.Cells[IntBuf,0]:='x'+IntToStr(IntBuf);
        SG_Eq.Cells[IntBuf,SG_Eq.RowCount-1]:='x'+IntToStr(IntBuf);
      end;
      EqSize:=loc_EqSize;
      If freeze then begin
        GuiFrozen:=true;
        SE_EqSize.Enabled:=false;
        SB_EqSize.Enabled:=false;
        SB_SolveEq.Enabled:=true;
        SB_SaveEQ.Enabled:=true;
      end else begin
        SE_EqSize.Enabled:=true;
        SB_EqSize.Enabled:=true;
        SB_SolveEq.Enabled:=false;
        SB_SaveEQ.Enabled:=false;
        GuiFrozen:=false;
      end;
    end else begin
      if freeze then begin
        GuiFrozen:=true;
        SB_SolveEq.Enabled:=true;
        SB_SaveEQ.Enabled:=true;
        SE_EqSize.Enabled:=false;
        SB_EqSize.Enabled:=false;
        SE_EqSize.Value:=SG_Eq.ColCount-2;
        EqSize:=SG_Eq.ColCount-2;
      end;
    end;
  end;

  function tFEqEdit.GuiToGlsys:tGlsys;
   var
    col,row:dword;
    abort:boolean=false; abortquestionasked:boolean=false;
  begin
    setlength(result,EqSize+1,EqSize+1);
    col:=0;row:=0;
    try
    while (col <= EqSize)and(not abort) do begin
      while (row < EqSize)and(not abort) do begin
        If SG_Eq.Cells[Col+1,Row+1]<>'' then begin
          result[col,row]:=StrToFloat(SG_Eq.Cells[Col+1,Row+1]);
        end else begin
          if not abortquestionasked then if MessageDlg('*Info*','Es gibt leere Felder. "Yes"=leere Felder=0, "No"=Abbruch für Korrektur', mtconfirmation, [mbYes,mbNo] , 0)=MrYes then
            abortquestionasked:=true  //If MrYes
          else begin                   //If MrNo
            abortquestionasked:=true;
            abort:=true;
          end;
          if not abort then result[col,row]:=0 else setlength(result,0,0);
        end;
        inc(row,1);
      end;
      row:=0;
      inc(Col,1);
    end;
    except
      MessageDlg('*Eingabefehler*','Mindestens ein Feld beeinhaltet keine zulässige Zahl. Bitte wiederholen Sie den Vorgang nach Korrektur des unzulässigen Eintrags!',mtError, [mbOk],0);
      setlength(result,0,0);
    end;
  end;

  function tFEqEdit.prepareOpenGlsys(NameOrPath:utf8string):dWord;
   var
     DefaultSet:textfile;
     pRow:longInt=0;
     i:longInt;
     s,buf:string;
    begin
      result:=0;
      If FileExistsUTF8(NameOrPath)then begin
        try
          AssignFile(DefaultSet,UTF8ToSys(NameOrPath));
          {$i-}
          Reset(DefaultSet);
          {$i+}
          while (not eof(DefaultSet))and(pRow=0)do begin
            readln(DefaultSet,s);
            pRow:=Pos('rowcount="',s);
            If pRow>0 then begin
              pRow:=pRow+10;
              i:=pRow;
              buf:='';
              while (Copy(s,i,1)<>'"')and(i<=length(s)) do begin
                buf:=buf+Copy(s,i,1);
                inc(i,1);
              end;
              try
                result:=StrToInt(Buf);
              except
              end;
            end;
          end;
        finally
          CloseFile(DefaultSet);
        end;
      end;
    end;

  procedure tFEqEdit.showResults(GlSys:tGlSys);
    var
      i:dWord;
  begin
    for i:=0 to EqSize-1 do begin
      SG_Eq.Cells[i+1,SG_Eq.RowCount-2]:=FloatToStr(Glsys[i,EqSize]);
    end;

  end;

procedure TFEqEdit.SB_EqSizeClick(Sender: TObject);
begin
  SetGui(true);
end;

procedure TFEqEdit.SB_LoadEqClick(Sender: TObject);
 var
   buf:dWord=0;
begin
  OD_Eq.Filter:='Gleichungssystem (*.pglsys)|*.pglsys';
  OD_Eq.DefaultExt:='.pglsys';
  if OD_Eq.Execute=true then begin
    if OD_Eq.FileName<>'' then begin
      Buf:=PrepareOpenGlsys(OD_Eq.FileName);
      If Buf>0 then begin
        EqSize:=Buf-3;
        SE_EqSize.Value:=Buf-3;
        GuiFrozen:=false;
        SetGui(true);
        SG_Eq.LoadFromFile(OD_Eq.FileName);
        SG_Eq.Enabled:=false;
        SG_Eq.Enabled:=true;
      end else MessageDlg('*Ausnahme-Fehler*','In der zu öffnenden Datei fehlt die Information über die Gleichungssystemgröße! Ladevorgang wird abgebrochen!',mtError, [mbOk],0);
    end;
  end;
end;

procedure TFEqEdit.SB_SaveEqClick(Sender: TObject);
begin
  SD_Eq.Filter:='Gleichungssystem (*.pglsys)|*.pglsys';
  SD_Eq.DefaultExt:='.pglsys';
  if SD_Eq.Execute=true then begin
    if SD_Eq.FileName<>'' then begin
      SG_Eq.SaveOptions:=[soDesign,soAttributes,soContent];
      SG_Eq.SaveToFile(SD_Eq.FileName);
    end;
  end;
end;

procedure TFEqEdit.SB_SolveEqClick(Sender: TObject);
 var
   ErrorCode:byte;
   ErrorStr:String;
   GlSys:tGlSys;
   i,z:dWord;
begin
  GlSys:=GuiToGlsys;
  If length(GlSys)<>0 then begin
    Numerik.SolveGLSys(GlSys,ErrorCode);
    Case ErrorCode of
      1: ErrorStr:='Die linke Seite ist linear Abhängig, die rechte nicht => keine wahre Aussage.';
      2: ErrorStr:='Eine Gleichung ist komplett linear abhängig von einer anderen => Dieses Gleichungssystem kann nur gelöst werden, '
                 +'falls auch ein Spalt komplett=0 (oder null-Variable). In diesem Fall geben Sie bitte ein neues Gleichungssystem ein ohne'
                 +' die null-Variable und streichen Sie eine der linear abhängigen Gleichungen. Promathika kann das NOCH nicht, da hierfür'
                 +' eine Änderung des Gleichungssystems erforderlich ist.';
      3: ErrorStr:='Die Gleichung enthält eine null-Zeile. Überdenken Sie bitte Ihre Eingabe bezüglich der Systemgröße und versuchen Sie es erneut. Falls KEINE Null-Variable vorliegt, kann DIESES System sowieso nicht gelöst werden.';
      4: ErrorStr:='Die Gleichung enthält einen null-Spalt. Somit liegen mehr Gleichungen als Variablen vor. Die Systemgröße passt nicht zu Ihren Vorgaben!';
      5: ErrorStr:='Mindestens eine Gleichung =0, deren Ergebnis<>0. Keine Wahre Aussage! Gleichung ist korrupt.';
      6: ErrorStr:='Bei der Berechnung ist leider ein unvorhergesehener Fehler aufgetreten. Bitte teilen Sie uns mit, falls diese Meldung auftaucht, damit wir den Bug so schnell wie möglich beheben.';
    end;
    If ErrorCode=0 then begin
      ShowResults(Glsys);
      SG_Eq.Enabled:=false;
      SG_Eq.Enabled:=true;
    end else begin
      MessageDlg('*Info*',ErrorStr,mtinformation,[mbOk],0);
      FoundErrors[ErrorCode]:=true;
      z:=0;
      for i:=1 to 5 do If FoundErrors[i]=true then inc(z,1);
      if z=5 then begin
        MessageDlg('*Info*','Sie haben sich viel Mühe bei der Suche nach Fehlern gegeben! Dafür bedanken wir uns bei Ihnen und würden uns über Ihr Feedback freuen!',mtinformation,[mbOk],0);
        for i:=1 to 5 do FoundErrors[i]:=false;
      end;
    end;
  end;
end;

procedure TFEqEdit.SE_EqSizeClick(Sender: TObject);
begin
  SetGui(false);
end;

procedure TFEqEdit.SE_EqSizeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If (key = 13) then begin
     key:= 0; //beep abschalten
     SetGui(true);
  end;
end;

procedure TFEqEdit.SG_EqClick(Sender: TObject);
  var
   i:dWord;
begin
  If not GuiFrozen then showmessage('Bitte legen Sie zuerst die Systemgröße fest und bestätigen Sie mit Enter oder "Ok". Dann erst kann die Tabelle editiert werden.');
  If SG_Eq.Cells[1,SG_Eq.RowCount-2]<>'' then begin
    for i:=1 to SG_Eq.ColCount-2 do SG_Eq.Cells[i,SG_Eq.RowCount-2]:='';
  end;
end;

procedure TFEqEdit.SG_EqDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
begin
    if aRow=SG_Eq.RowCount-2 then begin
      SG_Eq.Canvas.Brush.Color:=clblue;
      SG_Eq.Canvas.Pen.Color:=clBlack;
      SG_Eq.Canvas.FillRect(aRect);
      SG_Eq.Canvas.Font.Color:=clWhite;
    end;
    if aRow=SG_Eq.RowCount-1 then begin
      SG_Eq.Canvas.Brush.Color:=$0080FFFF;
      SG_Eq.Canvas.FillRect(aRect);
    end;
end;

procedure TFEqEdit.SG_EqSelectCell(Sender: TObject; aCol, aRow: Integer;
  var CanSelect: Boolean);
begin
  If (aRow>SG_Eq.RowCount-3)or(not GuiFrozen) then SG_Eq.Options:=SG_Eq.Options-[goEditing] else SG_Eq.Options:=SG_Eq.Options+[goEditing];

end;

procedure TFEqEdit.SB_EqResetClick(Sender: TObject);
begin
  Guifrozen:=false;
  Setgui(false);
end;

procedure TFEqEdit.FormShow(Sender: TObject);
 var
  i:dWord;
begin
  {$ifdef linux}
    FEqEdit.Font.Size:=9;
  {$endif}
  for i:=1 to 5 do FoundErrors[i]:=false;
  SetGui(false);
end;

procedure TFEqEdit.FormCreate(Sender: TObject);
begin
  Numerik:=tNumerik.create;
  GuiFrozen:=false;
end;

procedure TFEqEdit.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Numerik.free;
end;

initialization
  {$I ueqedit.lrs}

end.

